/* this file is autogenerated, do not edit directly */
/*
Kalles Fraktaler 2
Copyright (C) 2013-2017 Karl Runmo
Copyright (C) 2017-2018 Claude Heiland-Allen

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <windows.h>
#include <stdint.h>
#include "../fraktal_sft/floatexp.h"
#include "formula.h"

template <typename T> T sgn(const T &a)
{
  return (a > 0) - (a < 0);
}

static inline double d_add(const double a, const double b)
{
  return a + b;
}

static inline double d_addi(const double a, const int b)
{
  return a + b;
}

static inline double d_sub(const double a, const double b)
{
  return a - b;
}

static inline double d_isub(const int a, const double b)
{
  return a - b;
}

static inline double d_neg(const double a)
{
  return -a;
}

static inline double d_abs(const double a)
{
  return a < 0.0 ? -a : a;
}

static inline double d_sgn(const double a)
{
  return (a > 0.0) - (a < 0.0);
}

static inline double d_imul(const int a, const double b)
{
  return a * b;
}

static inline double d_muli(const double a, const int b)
{
  return a * b;
}

static inline double d_mul(const double a, const double b)
{
  return a * b;
}

static inline double d_pow(const double a, const int b)
{
  double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int d_cmp(const double a, const double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline double d_diffabs(const double c, const double d)
{
  double cd = c + d;
  if (c >= 0.0)
  {
    if (cd >= 0.0)
    {
      return d;
    }
    else
    {
      return -d - 2.0 * c;
    }
  }
  else
  {
    if (cd > 0.0)
    {
      return d + 2.0 * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline long double ld_add(const long double a, const long double b)
{
  return a + b;
}

static inline long double ld_addi(const long double a, const int b)
{
  return a + b;
}

static inline long double ld_sub(const long double a, const long double b)
{
  return a - b;
}

static inline long double ld_isub(const int a, const long double b)
{
  return a - b;
}

static inline long double ld_neg(const long double a)
{
  return -a;
}

static inline long double ld_abs(const long double a)
{
  return a < 0.0 ? -a : a;
}

static inline long double ld_sgn(const long double a)
{
  return (a > 0.0) - (a < 0.0);
}

static inline long double ld_imul(const int a, const long double b)
{
  return a * b;
}

static inline long double ld_muli(const long double a, const int b)
{
  return a * b;
}

static inline long double ld_mul(const long double a, const long double b)
{
  return a * b;
}

static inline long double ld_pow(const long double a, const int b)
{
  long double r = 1.0;
  for (int i = 0; i < b; ++i)
  {
    r *= a;
  }
  return r;
}

static inline int ld_cmp(const long double a, const long double b)
{
  return ((int)(a > b)) - ((int)(a < b));
}

static inline long double ld_diffabs(const long double c, const long double d)
{
  long double cd = c + d;
  if (c >= 0.0L)
  {
    if (cd >= 0.0L)
    {
      return d;
    }
    else
    {
      return - d - 2.0L * c;
    }
  }
  else
  {
    if (cd > 0.0L)
    {
      return d + 2.0L * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline int64_t as_long(double d)
{
  union {
    double d;
    int64_t i;
  } u;
  u.d = d;
  return u.i;
}

static inline double as_double(int64_t i)
{
  union {
    double d;
    int64_t i;
  } u;
  u.i = i;
  return u.d;
}

static inline double fe_double(floatexp f)
{
  if (f.exp < -1020)
  {
    return 0.0;
  }
  if (f.exp > 1020)
  {
    return f.val / 0.0;
  }
  return as_double((as_long(f.val) & 0x800FFFFFFFFFFFFFLL) | ((f.exp + 1023) << 52));
}

static inline floatexp fe_floatexp(const double val, const int64_t exp)
{
  int64_t f_exp = ((as_long(val) & 0x7FF0000000000000LL) >> 52) - 1023;
  double f_val = as_double((as_long(val) & 0x800FFFFFFFFFFFFFLL) | 0x3FF0000000000000LL);
  floatexp fe(f_val, f_exp + exp, 0);
  return fe;
}

static inline floatexp fe_abs(const floatexp f)
{
  floatexp fe(d_abs(f.val), f.exp, 0);
  return fe;
}

static inline floatexp fe_sgn(const floatexp a)
{
  return floatexp((a.val > 0.0) - (a.val < 0.0));
}

static inline floatexp fe_neg(const floatexp f)
{
  floatexp fe(-f.val, f.exp, 0);
  return fe;
}

static inline floatexp fe_muli(const floatexp a, const int b)
{
  return fe_floatexp(a.val * b, a.exp);
}

static inline floatexp fe_imul(const int a, const floatexp b)
{
  return fe_floatexp(a * b.val, b.exp);
}

static inline floatexp fe_mul(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val * b.val, a.exp + b.exp);
}

static inline floatexp fe_mul_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp + b, 0);
  return fe;
}

static inline floatexp fe_div(const floatexp a, const floatexp b)
{
  return fe_floatexp(a.val / b.val, a.exp - b.exp);
}

static inline floatexp fe_div_2si(const floatexp a, const int64_t b)
{
  floatexp fe(a.val, a.exp - b, 0);
  return fe;
}

static inline floatexp fe_add(const floatexp a, const floatexp b)
{
  if (a.exp > b.exp)
  {
    floatexp c(b.val, b.exp - a.exp, 0);
    return fe_floatexp(a.val + fe_double(c), a.exp);
  }
  else
  {
    floatexp c(a.val, a.exp - b.exp, 0);
    return fe_floatexp(fe_double(c) + b.val, b.exp);
  }
}

static inline floatexp fe_addi(const floatexp a, const int b)
{
  return fe_add(a, fe_floatexp(double(b), 0));
}

static inline floatexp fe_sub(const floatexp a, const floatexp b)
{
  return fe_add(a, fe_neg(b));
}

static inline floatexp fe_isub(const int a, const floatexp b)
{
  return fe_addi(fe_neg(b), a);
}

static inline int fe_cmp(const floatexp a, const floatexp b)
{
  if (a.val > 0)
  {
    if (b.val <= 0)
    {
      return 1;
    }
    else if (a.exp > b.exp)
    {
      return 1;
    }
    else if (a.exp < b.exp)
    {
      return -1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
  else
  {
    if (b.val > 0)
    {
      return -1;
    }
    else if (a.exp > b.exp)
    {
      return -1;
    }
    else if (a.exp < b.exp)
    {
      return 1;
    }
    else
    {
      return d_cmp(a.val, b.val);
    }
  }
}

static inline floatexp fe_diffabs(const floatexp c, const floatexp d)
{
  floatexp cd = fe_add(c, d);
  if (c.val >= 0.0)
  {
    if (cd.val >= 0.0)
    {
      return d;
    }
    else
    {
      return fe_neg(fe_add(d, fe_mul_2si(c, 1)));
    }
  }
  else
  {
    if (cd.val > 0.0)
    {
      return fe_add(d, fe_mul_2si(c, 1));
    }
    else
    {
      return fe_neg(d);
    }
  }
}

static inline floatexp fe_pow(const floatexp a, int b)
{
  floatexp r = fe_floatexp(1.0, 0);
  for (int i = 0; i < b; ++i)
  {
    r = fe_mul(r, a);
  }
  return r;
}

typedef struct
{
  double re;
  double im;
} dcomplex;

static inline dcomplex dc_neg(const dcomplex a)
{
  dcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline dcomplex dc_add(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline dcomplex dc_addi(const dcomplex a, const int b)
{
  dcomplex dc = { a.re + b, a.im };
  return dc;
}

static inline dcomplex dc_sub(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline dcomplex dc_isub(const int a, const dcomplex b)
{
  dcomplex dc = { a - b.re, - b.im };
  return dc;
}

static inline dcomplex dc_imul(const int a, const dcomplex b)
{
  dcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline dcomplex dc_muli(const dcomplex a, const int b)
{
  dcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline dcomplex dc_mul(const dcomplex a, const dcomplex b)
{
  dcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline dcomplex dc_pow(const dcomplex a, const int b)
{
  dcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = dc_mul(r, a);
  }
  return r;
}

typedef struct
{
  long double re;
  long double im;
} ldcomplex;

static inline ldcomplex ldc_neg(const ldcomplex a)
{
  ldcomplex dc = { -a.re, -a.im };
  return dc;
}

static inline ldcomplex ldc_add(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re + b.re, a.im + b.im };
  return dc;
}

static inline ldcomplex ldc_addi(const ldcomplex a, const int b)
{
  ldcomplex ldc = { a.re + b, a.im };
  return ldc;
}

static inline ldcomplex ldc_sub(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re - b.re, a.im - b.im };
  return dc;
}

static inline ldcomplex ldc_isub(const int a, const ldcomplex b)
{
  ldcomplex dc = { a - b.re, - b.im };
  return dc;
}

static inline ldcomplex ldc_imul(const int a, const ldcomplex b)
{
  ldcomplex dc = { a * b.re, a * b.im };
  return dc;
}

static inline ldcomplex ldc_muli(const ldcomplex a, const int b)
{
  ldcomplex dc = { a.re * b, a.im * b };
  return dc;
}

static inline ldcomplex ldc_mul(const ldcomplex a, const ldcomplex b)
{
  ldcomplex dc = { a.re * b.re - a.im * b.im, a.re * b.im + a.im * b.re };
  return dc;
}

static inline ldcomplex ldc_pow(const ldcomplex a, const int b)
{
  ldcomplex r = { 1.0, 0.0 };
  for (int i = 0; i < b; ++i)
  {
    r = ldc_mul(r, a);
  }
  return r;
}

typedef struct
{
  floatexp re;
  floatexp im;
} fecomplex;

static inline fecomplex fec_neg(const fecomplex a)
{
  fecomplex fec = { fe_neg(a.re), fe_neg(a.im) };
  return fec;
}

static inline fecomplex fec_add(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_add(a.re, b.re), fe_add(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_addi(const fecomplex a, const int b)
{
  fecomplex fec = { fe_addi(a.re, b), a.im };
  return fec;
}

static inline fecomplex fec_sub(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(a.re, b.re), fe_sub(a.im, b.im) };
  return fec;
}

static inline fecomplex fec_isub(const int a, const fecomplex b)
{
  fecomplex fec = { fe_isub(a, b.re), fe_neg(b.im) };
  return fec;
}

static inline fecomplex fec_imul(const int a, const fecomplex b)
{
  fecomplex fec = { fe_imul(a, b.re), fe_imul(a, b.im) };
  return fec;
}

static inline fecomplex fec_muli(const fecomplex a, const int b)
{
  fecomplex fec = { fe_muli(a.re, b), fe_muli(a.im, b) };
  return fec;
}

static inline fecomplex fec_mul(const fecomplex a, const fecomplex b)
{
  fecomplex fec = { fe_sub(fe_mul(a.re, b.re), fe_mul(a.im, b.im)), fe_add(fe_mul(a.re, b.im), fe_mul(a.im, b.re)) };
  return fec;
}

static inline fecomplex fec_pow(const fecomplex a, const int b)
{
  fecomplex r = { fe_floatexp(1.0, 0), fe_floatexp(0.0, 0) };
  for (int i = 0; i < b; ++i)
  {
    r = fec_mul(r, a);
  }
  return r;
}

static inline bool gezero(const double &x) { return x >= 0.0; }
static inline bool gtzero(const double &x) { return x >  0.0; }
static inline bool gezero(const long double &x) { return x >= 0.0; }
static inline bool gtzero(const long double &x) { return x >  0.0; }
static inline bool gezero(const floatexp &x) { return x.val >= 0.0; }
static inline bool gtzero(const floatexp &x) { return x.val >  0.0; }

template <typename T>
static inline T diffabs(const T &c, const T &d)
{
  T cd = c + d;
  if (gezero(c))
  {
    if (gezero(cd))
    {
      return d;
    }
    else
    {
      return -d - 2.0 * c;
    }
  }
  else
  {
    if (gtzero(cd))
    {
      return d + 2.0 * c;
    }
    else
    {
      return -d;
    }
  }
}

static inline long double ConvertFromFixedFloat(const CFixedFloat &f)
{
  using std::ldexp;
  signed long int e = 0;
  long double l = mpfr_get_ld_2exp(&e, f.m_f.backend().data(), MPFR_RNDN);
  l = ldexp(l, e);
  return l;
}

static inline double mpfr_get(const mpfr_t x, const double &t, mpfr_rnd_t rnd)
{
  (void) t;
  return mpfr_get_d(x, rnd);
}

static inline long double mpfr_get(const mpfr_t x, const long double &t, mpfr_rnd_t rnd)
{
  (void) t;
  return mpfr_get_ld(x, rnd);
}

static inline floatexp mpfr_get(const mpfr_t x, const floatexp &t, mpfr_rnd_t rnd)
{
  (void) t;
  signed long int e = 0;
  double d = mpfr_get_d_2exp(&e, x, rnd);
  return floatexp(d, e);
}


#include "../fraktal_sft/CFixedFloat.h"
#include "../fraktal_sft/floatexp.h"
#include "../fraktal_sft/complex.h"

#define FORMULA2(function,type,power) function ## _ ## type ## _ ## power
#define FORMULA(a,b,c) FORMULA2(a,b,c)

using std::abs;



template <typename T>
bool FORMULA(reference,0,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul(t0,t1,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa)); \
        dxbn = ((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab)); \
        dyan = ((2*(Xxi*dxa))+((2*(Xxr*dya))+dba)); \
        dybn = ((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_add(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul(t0,t1,t1,MPFR_RNDN);
mpfr_sub(t1,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        if (type_0_power_2_pixel_has_glitched(cr, ci, xr, xi, Xr, Xi, dxa / h, dya / h, e, h)) // FIXME matrix derivatives
        {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

        }

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=((2*(Xxi*dxa))+((2*(Xxr*dya))+dba));
dybn=((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb));
}

{xrn=(((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi))+cr);
xin=((2*((Xxr*xi)+(Xi*xr)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab))); \
        dyan = ((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba))); \
        dybn = ((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(((((((((((3*Xr)*Xr)*xr)-(((6*Xr)*Xi)*xi))-(((3*Xi)*Xi)*xr))+(((3*Xr)*xr)*xr))-(((3*Xr)*xi)*xi))-((((3*Xi)*2)*xr)*xi))+((xr*xr)*xr))-(((3*xr)*xi)*xi))+cr);
xin=(((((((((((3*Xr)*Xr)*xi)+(((6*Xr)*Xi)*xr))-(((3*Xi)*Xi)*xi))+((((3*Xr)*2)*xr)*xi))+(((3*Xi)*xr)*xr))-(((3*Xi)*xi)*xi))+(((3*xr)*xr)*xi))-((xi*xi)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{xrn=(((((((((((3*Xr)*Xr)*xr)-(((6*Xr)*Xi)*xi))-(((3*Xi)*Xi)*xr))+(((3*Xr)*xr)*xr))-(((3*Xr)*xi)*xi))-((((3*Xi)*2)*xr)*xi))+((xr*xr)*xr))-(((3*xr)*xi)*xi))+cr);
xin=(((((((((((3*Xr)*Xr)*xi)+(((6*Xr)*Xi)*xr))-(((3*Xi)*Xi)*xi))+((((3*Xr)*2)*xr)*xi))+(((3*Xi)*xr)*xr))-(((3*Xi)*xi)*xi))+(((3*xr)*xr)*xi))-((xi*xi)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = ((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba)))); \
        dybn = ((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb)))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 4) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{xn=((((((4*(X^3))*x)+((6*(X^2))*(x^2)))+((4*X)*(x^3)))+(x^4))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab))))); \
        dyan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))); \
        dybn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 5) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{xn=(((((((5*(X^4))*x)+((10*(X^3))*(x^2)))+((10*(X^2))*(x^3)))+((5*X)*(x^4)))+(x^5))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dr = dr0, di = di0;
    T drn = 0, din = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dr = drn; di = din; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        const complex<T> d(dr, di), d0(daa, dba);  \
        complex<T> dn(0.0, 0.0); \
         \
        dn = 6 * d * (Xx ^ 5) + d0; \
       \
        drn = dn.m_r; din = dn.m_i; \
 \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 6) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dr = dr0, di = di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T drn = 0, din = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((6*d)*(Xx^5))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((6*(X^5))*x)+((15*(X^4))*(x^2)))+((20*(X^3))*(x^3)))+((15*(X^2))*(x^4)))+((6*X)*(x^5)))+(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,7)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,7)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dr = dr0, di = di0;
    T drn = 0, din = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dr = drn; di = din; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        const complex<T> d(dr, di), d0(daa, dba);  \
        complex<T> dn(0.0, 0.0); \
         \
        dn = 7 * d * (Xx ^ 6) + d0; \
       \
        drn = dn.m_r; din = dn.m_i; \
 \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 7) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,7)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 7)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dr = dr0, di = di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T drn = 0, din = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((7*d)*(Xx^6))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((7*(X^6))*x)+((21*(X^5))*(x^2)))+((35*(X^4))*(x^3)))+((35*(X^3))*(x^4)))+((21*(X^2))*(x^5)))+((7*X)*(x^6)))+(x^7))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,8)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,8)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dr = dr0, di = di0;
    T drn = 0, din = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dr = drn; di = din; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        const complex<T> d(dr, di), d0(daa, dba);  \
        complex<T> dn(0.0, 0.0); \
         \
        dn = 8 * d * (Xx ^ 7) + d0; \
       \
        drn = dn.m_r; din = dn.m_i; \
 \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 8) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,8)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 8)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dr = dr0, di = di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T drn = 0, din = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((8*d)*(Xx^7))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((8*(X^7))*x)+((28*(X^6))*(x^2)))+((56*(X^5))*(x^3)))+((70*(X^4))*(x^4)))+((56*(X^3))*(x^5)))+((28*(X^2))*(x^6)))+((8*X)*(x^7)))+(x^8))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,9)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,9)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dr = dr0, di = di0;
    T drn = 0, din = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dr = drn; di = din; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        const complex<T> d(dr, di), d0(daa, dba);  \
        complex<T> dn(0.0, 0.0); \
         \
        dn = 9 * d * (Xx ^ 8) + d0; \
       \
        drn = dn.m_r; din = dn.m_i; \
 \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 9) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,9)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 9)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dr = dr0, di = di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T drn = 0, din = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((9*d)*(Xx^8))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=(((((((((((9*(X^8))*x)+((36*(X^7))*(x^2)))+((84*(X^6))*(x^3)))+((126*(X^5))*(x^4)))+((126*(X^4))*(x^5)))+((84*(X^3))*(x^6)))+((36*(X^2))*(x^7)))+((9*X)*(x^8)))+(x^9))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,0,10)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,0,10)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.01;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dr = dr0, di = di0;
    T drn = 0, din = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dr = drn; di = din; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        const complex<T> d(dr, di), d0(daa, dba);  \
        complex<T> dn(0.0, 0.0); \
         \
        dn = 10 * d * (Xx ^ 9) + d0; \
       \
        drn = dn.m_r; din = dn.m_i; \
 \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = (X ^ 10) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,0,10)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 0 && m_nPower == 10)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dr = dr0, di = di0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T drn = 0, din = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

      const complex<T> d = {dr, di}, d0 = {daa, dba}; 
      complex<T> dn;
{dn=(((10*d)*(Xx^9))+d0);
}
      drn = dn.m_r; din = dn.m_i;

{xn=((((((((((((10*(X^9))*x)+((45*(X^8))*(x^2)))+((120*(X^7))*(x^3)))+((210*(X^6))*(x^4)))+((252*(X^5))*(x^5)))+((210*(X^4))*(x^6)))+((120*(X^3))*(x^7)))+((45*(X^2))*(x^8)))+((10*X)*(x^9)))+(x^10))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dr = drn; di = din;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = dr; di0 = di;

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,1,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa)); \
        dxbn = ((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab)); \
        dyan = ((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba)); \
        dybn = ((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=((((((2*xr)*Xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi))+cr);
xin=((2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,1,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+daa))); \
        dxbn = ((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+dab))); \
        dyan = ((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+dba))); \
        dybn = ((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(((((Xr*Xr)-((3*Xi)*Xi))*diffabs(Xr,xr))+((((((2*Xr)*xr)+(xr*xr))-((6*Xi)*xi))-((3*xi)*xi))*abs((Xr+xr))))+cr);
xin=((((((3*Xr)*Xr)-(Xi*Xi))*diffabs(Xi,xi))+((((((6*Xr)*xr)+((3*xr)*xr))-((2*Xi)*xi))-(xi*xi))*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+daa)));
dxbn=((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+dab)));
dyan=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+dba)));
dybn=((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dbb)));
}

{xrn=(((((Xr*Xr)-((3*Xi)*Xi))*diffabs(Xr,xr))+((((((2*Xr)*xr)+(xr*xr))-((6*Xi)*xi))-((3*xi)*xi))*abs((Xr+xr))))+cr);
xin=((((((3*Xr)*Xr)-(Xi*Xi))*diffabs(Xi,xi))+((((((6*Xr)*xr)+((3*xr)*xr))-((2*Xi)*xi))-(xi*xi))*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,1,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+daa)))); \
        dxbn = ((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+dab)))); \
        dyan = ((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba)))); \
        dybn = ((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+daa))));
dxbn=((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+dab))));
dyan=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((-4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{xrn=((((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))-((((12*Xr)*Xr)*Xi)*xi))-((((6*Xr)*Xr)*xi)*xi))-((((12*Xr)*xr)*Xi)*Xi))-((((24*Xr)*xr)*Xi)*xi))-((((12*Xr)*xr)*xi)*xi))-((((6*xr)*xr)*Xi)*Xi))-((((12*xr)*xr)*Xi)*xi))-((((6*xr)*xr)*xi)*xi))+cr);
xin=((((4*((Xr*Xr)-(Xi*Xi)))*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+((4*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi))))*(((((2*xr)*Xr)+(xr*xr))-((2*xi)*Xi))-(xi*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,1,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,1,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+daa))))); \
        dxbn = ((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+dab))))); \
        dyan = ((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+dba))))); \
        dybn = ((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+dbb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_abs(t3,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,1,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 1 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+daa)))));
dxbn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+dab)))));
dyan=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))))+dba)))));
dybn=((5*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))))+((5*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+((20*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((-20*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))))+((-30*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))))+dbb)))));
}

{xrn=(((diffabs(Xr,xr)*(((((Xr*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+((((5*Xi)*Xi)*Xi)*Xi)))+(abs((Xr+xr))*(((((((((((((((((((4*Xr)*Xr)*Xr)*xr)+((((6*Xr)*Xr)*xr)*xr))+((((4*Xr)*xr)*xr)*xr))+(((xr*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((20*Xi)*Xi)*Xi)*xi))+((((30*Xi)*Xi)*xi)*xi))+((((20*Xi)*xi)*xi)*xi))+((((5*xi)*xi)*xi)*xi))))+cr);
xin=(((diffabs(Xi,xi)*((((((5*Xr)*Xr)*Xr)*Xr)-((((10*Xr)*Xr)*Xi)*Xi))+(((Xi*Xi)*Xi)*Xi)))+(abs((Xi+xi))*(((((((((((((((((((20*Xr)*Xr)*Xr)*xr)+((((30*Xr)*Xr)*xr)*xr))+((((20*Xr)*xr)*xr)*xr))+((((5*xr)*xr)*xr)*xr))-((((20*Xr)*Xr)*Xi)*xi))-((((10*Xr)*Xr)*xi)*xi))-((((20*Xr)*xr)*Xi)*Xi))-((((40*Xr)*xr)*Xi)*xi))-((((20*Xr)*xr)*xi)*xi))-((((10*xr)*xr)*Xi)*Xi))-((((20*xr)*xr)*Xi)*xi))-((((10*xr)*xr)*xi)*xi))+((((4*Xi)*Xi)*Xi)*xi))+((((6*Xi)*Xi)*xi)*xi))+((((4*Xi)*xi)*xi)*xi))+(((xi*xi)*xi)*xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,2,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa)); \
        dxbn = ((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab)); \
        dyan = ((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba)); \
        dybn = ((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=(ci-(2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+dba));
dybn=((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+(xr*xr))-((2*Xi)*xi))-(xi*xi)))+cr);
xin=(ci-(2*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,2,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab))); \
        dyan = ((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba))); \
        dybn = ((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{xrn=(diffabs((Xr*((Xr*Xr)-((3*Xi)*Xi))),(((xr*(((3*Xr)*Xr)+(xr*xr)))+((3*Xr)*(((xr*xr)-((2*Xi)*xi))-(xi*xi))))-((3*xr)*(((Xi*Xi)+((2*Xi)*xi))+(xi*xi)))))+cr);
xin=(diffabs((Xi*(((3*Xr)*Xr)-(Xi*Xi))),((((3*Xi)*((((2*Xr)*xr)+(xr*xr))-(xi*xi)))+((3*xi)*(((Xr*Xr)+((2*Xr)*xr))+(xr*xr))))-(xi*(((3*Xi)*Xi)+(xi*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,2,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = ((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba)))); \
        dybn = ((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2)))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,2,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,2,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab))))); \
        dyan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dba))))); \
        dybn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dbb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,2,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 2 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(Xxi*(Xxi*(Xxi*(Xxr*Xxr)))))+(5*(Xxi*(Xxr*(Xxr*(Xxr*Xxr))))))))))))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,3,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa)); \
        dxbn = ((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab)); \
        dyan = ((2*(Xxi*dxa))+((2*(Xxr*dya))+dba)); \
        dybn = ((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((2*(Xxi*dxa))+((2*(Xxr*dya))+dba));
dybn=((2*(Xxi*dxb))+((2*(Xxr*dyb))+dbb));
}

{xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),((((2*Xr)+xr)*xr)-(((2*Xi)+xi)*xi)))+cr);
xin=((((2*Xr)*xi)+((2*xr)*(Xi+xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,3,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab))); \
        dyan = ((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba))); \
        dybn = ((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxa*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dya*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+daa)));
dxbn=((3*(Xxr*(Xxr*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-3*(Xxi*(Xxi*(dxb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dyb*sgn(((-3*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))))))+dab)));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((Xr*(Xr2-(3*Xi2))),(((xr*((3*Xr2)+xr2))+((3*Xr)*((xr2-((2*Xi)*xi))-xi2)))-((3*xr)*((Xi2+((2*Xi)*xi))+xi2))))+cr);
xin=(((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*(xi2+(3*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,3,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = ((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba)))); \
        dybn = ((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,3,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,3,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab))))); \
        dyan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))); \
        dybn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,3,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 3 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((((Xr2*Xr2)*Xr)-(((10*Xr2)*Xr)*Xi2))+(((5*Xr)*Xi2)*Xi2)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,4,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa)); \
        dxbn = ((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab)); \
        dyan = ((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba)); \
        dybn = ((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((-2*(Xxi*dya))+((2*(Xxr*dxa))+daa));
dxbn=((-2*(Xxi*dyb))+((2*(Xxr*dxb))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=(ci-(2*(((Xr*xi)+(xr*Xi))+(xr*xi))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,4,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab))); \
        dyan = ((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba))); \
        dybn = ((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,Cr,t0,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((cr-(xr*((3*Xr2)+xr2)))+((3*Xr)*((xi2+((2*Xi)*xi))-xr2)))+((3*xr)*((Xi2+((2*Xi)*xi))+xi2)));
xin=(((((((((((6*Xr)*Xi)*xr)+((3*Xi)*xr2))-((3*Xi2)*xi))-((3*Xi)*xi2))+((3*Xr2)*xi))+(((6*Xr)*xr)*xi))+((3*xr2)*xi))-(xi2*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,4,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = ((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba)))); \
        dybn = ((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((((((((((((((-12*Xr2)*Xi)*xr)-(((12*Xr)*Xi)*xr2))+(((12*Xr)*Xi2)*xi))+(((12*Xr)*Xi)*xi2))-(((4*Xr2)*Xr)*xi))-(((12*Xr2)*xi)*xr))-(((12*Xr)*xi)*xr2))+(((4*Xr)*xi2)*xi))-(((4*xr2)*xr)*Xi))+(((4*xr)*Xi2)*Xi))+(((12*xr)*Xi2)*xi))+(((12*xr)*Xi)*xi2))-(((4*xr2)*xr)*xi))+(((4*xr)*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,4,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,4,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab))))); \
        dyan = ((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))); \
        dybn = ((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_add(t2,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,4,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 4 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((((((((((((((((((((5*Xr2)*Xr2)*xr)+(((10*Xr2)*Xr)*xr2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xr2)*xr2))-((((20*Xr2)*Xr)*Xi)*xi))-(((10*Xr2)*Xr)*xi2))-(((30*Xr2)*xr)*Xi2))-((((60*Xr2)*xr)*Xi)*xi))-(((30*Xr2)*xr)*xi2))-(((30*Xr)*xr2)*Xi2))-((((60*Xr)*xr2)*Xi)*xi))-(((30*Xr)*xr2)*xi2))+((((20*Xr)*Xi2)*Xi)*xi))+(((30*Xr)*Xi2)*xi2))+((((20*Xr)*Xi)*xi2)*xi))+(((5*Xr)*xi2)*xi2))+((xr2*xr2)*xr))-(((10*xr2)*xr)*Xi2))-((((20*xr2)*xr)*Xi)*xi))-(((10*xr2)*xr)*xi2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*Xi2)*Xi)*xi))+(((30*xr)*Xi2)*xi2))+((((20*xr)*Xi)*xi2)*xi))+(((5*xr)*xi2)*xi2))+cr);
xin=(((((((((((((((((((((((((((((-20*Xi)*Xr2)*Xr)*xr)-(((30*Xi)*Xr2)*xr2))-((((20*Xi)*Xr)*xr2)*xr))-(((5*Xi)*xr2)*xr2))+(((30*Xi2)*Xr2)*xi))+(((30*Xi)*Xr2)*xi2))+((((20*Xi2)*Xi)*Xr)*xr))+((((60*Xi2)*Xr)*xr)*xi))+((((60*Xi)*Xr)*xr)*xi2))+(((10*Xi2)*Xi)*xr2))+(((30*Xi2)*xr2)*xi))+(((30*Xi)*xr2)*xi2))-(((5*Xi2)*Xi2)*xi))-(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*xi2)*xi))-(((5*Xi)*xi2)*xi2))-(((5*xi)*Xr2)*Xr2))-((((20*xi)*Xr2)*Xr)*xr))-(((30*xi)*Xr2)*xr2))-((((20*xi)*Xr)*xr2)*xr))-(((5*xi)*xr2)*xr2))+(((10*xi2)*xi)*Xr2))+((((20*xi2)*xi)*Xr)*xr))+(((10*xi2)*xi)*xr2))-((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,5,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,5,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa)); \
        dxbn = ((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab)); \
        dyan = ((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba)); \
        dybn = ((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb)); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,5,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 5 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=((-2*(Xxi*dxa))+((-2*(Xxr*dya))+dba));
dybn=((-2*(Xxi*dxb))+((-2*(Xxr*dyb))+dbb));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=(((((Xr*xi)+(xr*Xi))+(xr*xi))*-2)+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,6,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,6,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa)); \
        dxbn = ((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab)); \
        dyan = (dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya)))); \
        dybn = (dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,6,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 6 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,7,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,7,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa)); \
        dxbn = ((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab)); \
        dyan = (dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa)))); \
        dybn = (dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t0,Xr,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,2,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,7,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 7 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*dxa))+((-2*(Xxi*dya))+daa));
dxbn=((2*(Xxr*dxb))+((-2*(Xxi*dyb))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((2*Xr)*xr)+xr2)-xi2)-((2*xi)*Xi))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,8,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,8,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa)); \
        dxbn = ((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab)); \
        dyan = (dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya)))); \
        dybn = (dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,8,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 8 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxi*(dxa*sgn(Xxr))))+(-2*(abs(Xxr)*dya))));
dybn=(dbb+((-2*(Xxi*(dxb*sgn(Xxr))))+(-2*(abs(Xxr)*dyb))));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((abs((Xr+xr))*xi)*-2)+((diffabs(Xr,xr)*Xi)*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,9,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,9,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa)); \
        dxbn = ((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab)); \
        dyan = (dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa)))); \
        dybn = (dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,2,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,9,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 9 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+daa));
dxbn=((2*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+((-2*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))+dab));
dyan=(dba+((-2*(Xxr*(dya*sgn(Xxi))))+(-2*(abs(Xxi)*dxa))));
dybn=(dbb+((-2*(Xxr*(dyb*sgn(Xxi))))+(-2*(abs(Xxi)*dxb))));
}

{const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs(((Xr*Xr)-(Xi*Xi)),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))+cr);
xin=((((diffabs(Xi,xi)*Xr)*-2)+((xr*abs((Xi+xi)))*-2))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,10,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,10,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa)))); \
        dxbn = ((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab)))); \
        dyan = ((-3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba))); \
        dybn = ((-3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,10,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 10 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((-3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((-3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=(ci-diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2)))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,11,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,11,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa)))); \
        dxbn = ((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab)))); \
        dyan = ((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba))); \
        dybn = ((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,11,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 11 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)));
dybn=((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((((((6*Xr)*((Xi*xr)+(xr*xi)))+((3*Xi)*(xr2-xi2)))+((3*xi)*(Xr2-Xi2)))+(xi*((3*xr2)-xi2)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,12,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,12,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab))); \
        dyan = ((-1*(Xxi*(Xxi*(dya*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dya)))+((3*(Xxr*(Xxr*(dya*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxa)))+dba)))); \
        dybn = ((-1*(Xxi*(Xxi*(dyb*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dyb)))+((3*(Xxr*(Xxr*(dyb*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxb)))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,12,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 12 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((-1*(Xxi*(Xxi*(dya*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dya)))+((3*(Xxr*(Xxr*(dya*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxa)))+dba))));
dybn=((-1*(Xxi*(Xxi*(dyb*sgn(Xxi)))))+((-2*(abs(Xxi)*(Xxi*dyb)))+((3*(Xxr*(Xxr*(dyb*sgn(Xxi)))))+((6*(abs(Xxi)*(Xxr*dxb)))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(((((3*Xr2)-Xi2)*diffabs(Xi,xi))+((((((6*xr)*Xr)+(3*xr2))-((2*Xi)*xi))-xi2)*abs((Xi+xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,13,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,13,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa))); \
        dxbn = ((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab))); \
        dyan = ((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba))); \
        dybn = ((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,Xr,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,3,MPFR_RNDN);
mpfr_sub(t0,t1,Xi2,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,13,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 13 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)));
dxbn=((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)));
dyan=((3*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dba)));
dybn=((3*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((-3*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+((6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(3*(Xxi*(Xxr*Xxr)))))))))+dbb)));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((3*Xr2)*xr)+((3*Xr)*xr2))-(((6*Xr)*Xi)*xi))-((3*Xr)*xi2))+(xr*xr2))-((3*Xi2)*xr))-(((6*Xi)*xr)*xi))-((3*xr)*xi2))+cr);
xin=(diffabs((Xi*((3*Xr2)-Xi2)),((((3*Xi)*((((2*Xr)*xr)+xr2)-xi2))+((3*xi)*((Xr2+((2*Xr)*xr))+xr2)))-(xi*((3*Xi2)+xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,14,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,14,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa)))); \
        dxbn = ((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab)))); \
        dyan = (dba+((2*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dya))))); \
        dybn = (dbb+((2*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dyb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul_ui(t0,Xi2,3,MPFR_RNDN);
mpfr_sub(t1,Xr2,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,3,MPFR_RNDN);
mpfr_sub(t2,t0,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,14,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 14 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(dxa*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxa)))+((-3*(Xxi*(Xxi*(dxa*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dya)))+daa))));
dxbn=((Xxr*(Xxr*(dxb*sgn(Xxr))))+((2*(abs(Xxr)*(Xxr*dxb)))+((-3*(Xxi*(Xxi*(dxb*sgn(Xxr)))))+((-6*(abs(Xxr)*(Xxi*dyb)))+dab))));
dyan=(dba+((2*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dya)))));
dybn=(dbb+((2*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+((-6*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))))))+(-1*(abs(((-1*(Xxi*Xxi))+(3*(Xxr*Xxr))))*dyb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((Xr2-(3*Xi2))*diffabs(Xr,xr))+((((((2*xr)*Xr)+xr2)-((6*Xi)*xi))-(3*xi2))*abs((Xr+xr))))+cr);
xin=((ci-(diffabs(((3*Xr2)-Xi2),(((((6*Xr)*xr)+(3*xr2))-((2*Xi)*xi))-xi2))*Xi))-(abs(((((((3*Xr2)+((6*Xr)*xr))+(3*xr2))-Xi2)-((2*Xi)*xi))-xi2))*xi));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,15,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,15,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxr*(Xxr*(Xxr*dxa))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxa)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+daa)))); \
        dxbn = ((4*(Xxr*(Xxr*(Xxr*dxb))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxb)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+dab)))); \
        dyan = (dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa)))))); \
        dybn = (dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_abs(t1,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,15,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 15 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxr*(Xxr*(Xxr*dxa))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxa)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*dxb))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))))+((-12*(abs((Xxi*Xxi))*(Xxr*dxb)))+((-12*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,16,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,16,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab)))); \
        dyan = (dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya)))))); \
        dybn = (dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,16,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 16 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,17,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,17,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab)))); \
        dyan = (dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dya)))))); \
        dybn = (dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul_ui(t1,t0,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,17,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 17 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dya)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+((-12*(abs((Xxr*Xxr))*(Xxi*dyb)))+((-12*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((-12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(-4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,18,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,18,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxa))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))+daa)))); \
        dxbn = ((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxb))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))+dab)))); \
        dyan = (dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa)))))); \
        dybn = (dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_abs(t0,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,18,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 18 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxa))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))+daa))));
dxbn=((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi))))))))))))+((4*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-12*(abs((Xxi*Xxi))*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(Xxr*dxb))))+((-12*(sgn(((Xxr*(Xxr*(Xxr*Xxr)))+((-6*(abs((Xxi*Xxi))*(Xxr*Xxr)))+abs((Xxi*(Xxi*(Xxi*Xxi)))))))*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxa))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))+((12*(abs(Xxi)*(Xxr*(Xxr*dxb))))+((-12*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))+(-4*(abs((Xxi*(Xxi*Xxi)))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xi+xi))*(((((((((12*Xr2)*xr)+((12*Xr)*xr2))+((4*xr2)*xr))-((4*xr)*Xi2))-(((8*xi)*Xr)*Xi))-(((8*xr)*xi)*Xi))-((4*xi2)*Xr))-((4*xr)*xi2)))+(diffabs(Xi,xi)*(((4*Xr2)*Xr)-((4*Xr)*Xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,19,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,19,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dya))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dyb))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+dab)))); \
        dyan = (dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya)))))); \
        dybn = (dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_add(t0,t2,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,19,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 19 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dya))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr))))))))))))+((4*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(Xxi*dyb))))+((-12*(sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(abs((Xxr*Xxr))*(Xxi*Xxi)))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dya))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))+((-12*(abs(Xxr)*(Xxi*(Xxi*dyb))))+((12*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))+(4*(abs((Xxr*(Xxr*Xxr)))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((4*Xr2)*xi)+(((8*Xr)*xr)*Xi))+(((8*Xr)*xr)*xi))+((4*xr2)*Xi))+((4*xr2)*xi))-((12*xi)*Xi2))-((12*xi2)*Xi))-((4*xi2)*xi)))+(diffabs(Xr,xr)*(((4*Xr2)*Xi)-((4*Xi2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,20,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,20,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa)))); \
        dxbn = ((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*(-6))+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab)))); \
        dyan = ((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba)))); \
        dybn = ((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_mul_ui(t0,t1,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,20,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 20 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))));
dxbn=((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((4*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-12*(sgn((abs((Xxi*(Xxi*(Xxi*Xxi))))+((abs((Xxi*(Xxi*(Xxr*Xxr))))*-6)+abs((Xxr*(Xxr*(Xxr*Xxr)))))))*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))));
dyan=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+dba))));
dybn=((-4*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))))+((4*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))))+((12*(sgn(Xxi)*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))))+((-12*(sgn(Xxi)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((abs((Xr+xr))*(((((((((12*Xi2)*xi)+((12*Xi)*xi2))+((4*xi2)*xi))-(((8*xr)*Xr)*Xi))-((4*xr2)*Xi))-((4*xi)*Xr2))-(((8*xr)*xi)*Xr))-((4*xr2)*xi)))+(diffabs(Xr,xr)*(((4*Xi2)*Xi)-((4*Xr2)*Xi))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,21,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,21,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = ((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba)))); \
        dybn = ((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,21,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 21 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dba))));
dybn=((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-4*(Xxi*(Xxi*(Xxi*Xxr))))+(4*(Xxi*(Xxr*(Xxr*Xxr)))))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(diffabs(((((4*Xr2)*Xr)*Xi)-(((4*Xr)*Xi2)*Xi)),((((((((((((((((-4*xr)*Xi2)*Xi)-(((12*xi)*Xr)*Xi2))-(((12*xr)*xi)*Xi2))+(((12*xr)*Xr2)*Xi))-(((12*xi2)*Xr)*Xi))+(((12*xr2)*Xr)*Xi))-(((12*xr)*xi2)*Xi))+(((4*xr2)*xr)*Xi))+(((4*xi)*Xr2)*Xr))+(((12*xr)*xi)*Xr2))-(((4*xi2)*xi)*Xr))+(((12*xr2)*xi)*Xr))-(((4*xr)*xi2)*xi))+(((4*xr2)*xr)*xi)))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,22,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,22,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = ((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+dba)))); \
        dybn = ((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t2,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,22,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 22 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+dba))));
dybn=((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(ci-((((((((((((((((12*Xr2)*Xi)*xr)+(((12*Xr)*Xi)*xr2))-(((12*Xr)*Xi2)*xi))-(((12*Xr)*Xi)*xi2))+(((4*Xr2)*Xr)*xi))+(((12*Xr2)*xi)*xr))+(((12*Xr)*xi)*xr2))-(((4*Xr)*xi2)*xi))+(((4*xr2)*xr)*Xi))-(((4*xr)*Xi2)*Xi))-(((12*xr)*Xi2)*xi))-(((12*xr)*Xi)*xi2))+(((4*xr2)*xr)*xi))-(((4*xr)*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,23,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,23,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab)))); \
        dyan = ((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba)))); \
        dybn = ((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,23,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 23 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,24,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,24,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab)))); \
        dyan = ((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba)))); \
        dybn = ((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,24,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 24 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxr*(Xxr*dya)))+((-24*(Xxi*(Xxr*dxa)))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxr*(Xxr*dyb)))+((-24*(Xxi*(Xxr*dxb)))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,25,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,25,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab)))); \
        dyan = ((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba)))); \
        dybn = ((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_neg(t1,t1,MPFR_RNDN);mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,25,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 25 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((-8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((-4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((-8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((-(((4*Xr)*Xi))*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))-(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,26,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,26,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab)))); \
        dyan = ((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba)))); \
        dybn = ((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb)))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_add(t2,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,26,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 26 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+((-24*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-12*(Xxi*(Xxr*Xxr)))+(Xxr*(Xxr*(Xxr*Xxr))))))))))+dab))));
dyan=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))));
dybn=((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((4*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*xr)*Xr)*Xi2))-((6*xr2)*Xi2))-(((12*xi)*Xr2)*Xi))-((((24*xr)*xi)*Xr)*Xi))-(((12*xr2)*xi)*Xi))-((6*xi2)*Xr2))-(((12*xr)*xi2)*Xr))-((6*xr2)*xi2)))+cr);
xin=(((((4*Xr)*Xi)*diffabs((Xr2-Xi2),(((((-2*xi)*Xi)+((2*xr)*Xr))-xi2)+xr2)))+(((((4*Xr)*xi)+((4*xr)*Xi))+((4*xr)*xi))*abs((((((-(Xi2)-((2*xi)*Xi))+Xr2)+((2*xr)*Xr))-xi2)+xr2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,27,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,27,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab))))); \
        dyan = (dba+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya))))))); \
        dybn = (dbb+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,27,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 27 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,28,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,28,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab))))); \
        dyan = (dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya))))))); \
        dybn = (dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_sub(t1,Ci,t0,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,28,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 28 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dya))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dya)))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((20*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))+((-20*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((30*(abs((Xxr*Xxr))*(Xxi*(Xxi*dyb))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,29,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,29,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab))))); \
        dyan = ((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))); \
        dybn = ((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,10,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xi2,5,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_add(t2,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xr,t2,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_add(t0,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,5,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_mul_ui(t0,Xr2,10,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_sub(t0,t2,t1,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,29,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 29 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(((5*(Xxi*(Xxi*(Xxi*(Xxi*Xxr)))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*Xxr)))))+(Xxr*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+dab)))));
dyan=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))));
dybn=((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((((5*Xr)*Xi2)*Xi2)-(((10*Xr2)*Xr)*Xi2))+((Xr2*Xr2)*Xr)),((((((((((((((((((((((((((((20*Xr)*xi)*Xi2)*Xi)-(((30*Xr2)*xr)*Xi2))+(((30*Xr)*xi2)*Xi2))-(((30*Xr)*xr2)*Xi2))-((((20*Xr2)*Xr)*xi)*Xi))-((((60*Xr2)*xr)*xi)*Xi))+((((20*Xr)*xi2)*xi)*Xi))-((((60*Xr)*xr2)*xi)*Xi))+(((5*Xr2)*Xr2)*xr))-(((10*Xr2)*Xr)*xi2))+(((10*Xr2)*Xr)*xr2))-(((30*Xr2)*xr)*xi2))+(((10*Xr2)*xr2)*xr))+(((5*Xr)*xi2)*xi2))-(((30*Xr)*xr2)*xi2))+(((5*Xr)*xr2)*xr2))+(((5*xr)*Xi2)*Xi2))+((((20*xr)*xi)*Xi2)*Xi))+(((30*xr)*xi2)*Xi2))-(((10*xr2)*xr)*Xi2))+((((20*xr)*xi2)*xi)*Xi))-((((20*xr2)*xr)*xi)*Xi))+(((5*xr)*xi2)*xi2))-(((10*xr2)*xr)*xi2))+((xr2*xr2)*xr)))+cr);
xin=(ci-((((((((((((((((((((((((((((20*Xi)*Xr2)*Xr)*xr)+(((30*Xi)*Xr2)*xr2))+((((20*Xi)*Xr)*xr2)*xr))+(((5*Xi)*xr2)*xr2))-(((30*Xi2)*Xr2)*xi))-(((30*Xi)*Xr2)*xi2))-((((20*Xi2)*Xi)*Xr)*xr))-((((60*Xi2)*Xr)*xr)*xi))-((((60*Xi)*Xr)*xr)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xr2)*xi))-(((30*Xi)*xr2)*xi2))+(((5*Xi2)*Xi2)*xi))+(((10*Xi2)*Xi)*xi2))+(((10*Xi2)*xi2)*xi))+(((5*Xi)*xi2)*xi2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*Xr2)*Xr)*xr))+(((30*xi)*Xr2)*xr2))+((((20*xi)*Xr)*xr2)*xr))+(((5*xi)*xr2)*xr2))-(((10*xi2)*xi)*Xr2))-((((20*xi2)*xi)*Xr)*xr))-(((10*xi2)*xi)*xr2))+((xi2*xi2)*xi)));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,30,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,30,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa))))); \
        dxbn = ((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab))))); \
        dyan = (dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dya)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dya)))))))); \
        dybn = (dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dyb)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dyb)))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_mul(t0,Xi,t1,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,30,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 30 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dya)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))+daa)))));
dxbn=((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((5*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+((-20*(abs((Xxr*(Xxr*Xxr)))*(Xxi*dyb)))+((-30*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))+dab)))));
dyan=(dba+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dya)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dya))))))));
dybn=(dbb+((-5*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))))))))+((20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))))+((-20*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(sgn(Xxr)*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))))))+((30*(abs((Xxr*Xxr))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*(Xxi*(Xxi*dyb)))))+(-5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*(sgn(((Xxi*(Xxi*(Xxi*(Xxi*Xxi))))+((-10*(abs((Xxr*Xxr))*(Xxi*(Xxi*Xxi))))+(5*(abs((Xxr*(Xxr*(Xxr*Xxr))))*Xxi)))))*dyb))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(ci-diffabs(((((Xi2*Xi2)*Xi)-(((10*Xi2)*Xi)*Xr2))+(((5*Xi)*Xr2)*Xr2)),(((((((((((((((((((((((((((5*Xi2)*Xi2)*xi)-((((20*Xi2)*Xi)*xr)*Xr))+(((10*Xi2)*Xi)*xi2))-(((10*Xi2)*Xi)*xr2))-(((30*Xi2)*xi)*Xr2))-((((60*Xi2)*xr)*xi)*Xr))+(((10*Xi2)*xi2)*xi))-(((30*Xi2)*xr2)*xi))+((((20*Xi)*xr)*Xr2)*Xr))-(((30*Xi)*xi2)*Xr2))+(((30*Xi)*xr2)*Xr2))-((((60*Xi)*xr)*xi2)*Xr))+((((20*Xi)*xr2)*xr)*Xr))+(((5*Xi)*xi2)*xi2))-(((30*Xi)*xr2)*xi2))+(((5*Xi)*xr2)*xr2))+(((5*xi)*Xr2)*Xr2))+((((20*xi)*xr)*Xr2)*Xr))-(((10*xi2)*xi)*Xr2))+(((30*xi)*xr2)*Xr2))-((((20*xi2)*xi)*xr)*Xr))+((((20*xi)*xr2)*xr)*Xr))+((xi2*xi2)*xi))-(((10*xi2)*xi)*xr2))+(((5*xi)*xr2)*xr2))));
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,31,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,31,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa))))))); \
        dxbn = ((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab))))))); \
        dyan = (dba+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya))))))); \
        dybn = (dbb+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_sub(t0,Ci,t1,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,31,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 31 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya)))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(-1*(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb)))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((-(Xi)*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))-(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,32,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,32,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.00001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa))))))); \
        dxbn = ((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab))))))); \
        dyan = (dba+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya)))))); \
        dybn = (dbb+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xr,MPFR_RNDN);
mpfr_mul(t1,Xr2,Xr2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,10,MPFR_RNDN);
mpfr_mul(t3,t2,Xi2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xi2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xi2,MPFR_RNDN);
mpfr_add(t3,t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,5,MPFR_RNDN);
mpfr_mul(t1,t3,Xr2,MPFR_RNDN);
mpfr_mul_ui(t3,Xr2,10,MPFR_RNDN);
mpfr_mul(t0,t3,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t0,MPFR_RNDN);
mpfr_mul(t0,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t1,t3,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,t0,MPFR_RNDN);
mpfr_add(t0,t1,Ci,MPFR_RNDN);
mpfr_set(Xin,t0,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,32,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 32 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxa)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxa)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dya)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dya)))))+daa)))))));
dxbn=((Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))+((4*(abs(Xxr)*(Xxr*(Xxr*(Xxr*dxb)))))+((5*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-10*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-20*(abs(Xxr)*(Xxi*(Xxi*(Xxr*dxb)))))+((-20*(abs(Xxr)*(Xxi*(Xxr*(Xxr*dyb)))))+((20*(abs(Xxr)*(Xxi*(Xxi*(Xxi*dyb)))))+dab)))))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))))))))+(abs(((Xxi*(Xxi*(Xxi*Xxi)))+((-10*(Xxi*(Xxi*(Xxr*Xxr))))+(5*(Xxr*(Xxr*(Xxr*Xxr)))))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((diffabs(Xr,xr)*(((Xr2*Xr2)-((10*Xr2)*Xi2))+((5*Xi2)*Xi2)))+(abs((Xr+xr))*((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))-(((20*Xr2)*Xi)*xi))-((10*Xr2)*xi2))-(((20*Xr)*xr)*Xi2))-((((40*Xr)*xr)*Xi)*xi))-(((20*Xr)*xr)*xi2))-((10*xr2)*Xi2))-(((20*xr2)*Xi)*xi))-((10*xr2)*xi2))+(((20*Xi2)*Xi)*xi))+((30*Xi2)*xi2))+(((20*Xi)*xi2)*xi))+((5*xi2)*xi2))))+cr);
xin=(((Xi*diffabs(((((5*Xr2)*Xr2)-((10*Xr2)*Xi2))+(Xi2*Xi2)),((((((((((((((((((4*xi)*Xi2)*Xi)-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2))))+(xi*abs((((((((((((((((((((Xi2*Xi2)+(((4*xi)*Xi2)*Xi))-((10*Xr2)*Xi2))-(((20*xr)*Xr)*Xi2))+((6*xi2)*Xi2))-((10*xr2)*Xi2))-(((20*xi)*Xr2)*Xi))-((((40*xr)*xi)*Xr)*Xi))+(((4*xi2)*xi)*Xi))-(((20*xr2)*xi)*Xi))+((5*Xr2)*Xr2))+(((20*xr)*Xr2)*Xr))-((10*xi2)*Xr2))+((30*xr2)*Xr2))-(((20*xr)*xi2)*Xr))+(((20*xr2)*xr)*Xr))+(xi2*xi2))-((10*xr2)*xi2))+((5*xr2)*xr2)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,33,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,33,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(abs((Xxr*Xxr))*(Xxr*dxa)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxa)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dya)))+((2*(abs((Xxi*Xxi))*(Xxi*dya)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa)))))))))))); \
        dxbn = ((2*(abs((Xxr*Xxr))*(Xxr*dxb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxb)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dyb)))+((2*(abs((Xxi*Xxi))*(Xxi*dyb)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab)))))))))))); \
        dyan = ((2*(abs((Xxr*Xxr))*(Xxr*dya)))+((-2*(abs((Xxi*Xxi))*(Xxr*dya)))+((2*(abs((Xxr*Xxr))*(Xxi*dxa)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxa)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi)))))))+dba)))))))))))); \
        dybn = ((2*(abs((Xxr*Xxr))*(Xxr*dyb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dyb)))+((2*(abs((Xxr*Xxr))*(Xxi*dxb)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxb)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi)))))))+dbb)))))))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_abs(t0,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xi2,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t3,t2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_mul(t3,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,Xr2,t3,MPFR_RNDN);
mpfr_sub(t3,t2,t1,MPFR_RNDN);
mpfr_abs(t1,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi2,t1,MPFR_RNDN);
mpfr_sub(t1,t3,t2,MPFR_RNDN);
mpfr_abs(t2,Xr2,MPFR_RNDN);
mpfr_mul(t3,Xr2,t2,MPFR_RNDN);
mpfr_add(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t2,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xi2,MPFR_RNDN);
mpfr_mul(t1,t2,t3,MPFR_RNDN);
mpfr_sub(t3,Ci,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t1,t0,MPFR_RNDN);
mpfr_sub(t0,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr2,2,MPFR_RNDN);
mpfr_mul(t3,Xr,Xi,MPFR_RNDN);
mpfr_abs(t1,t3,MPFR_RNDN);
mpfr_mul(t3,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,t3,MPFR_RNDN);
mpfr_mul_ui(t3,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t3,Xi,MPFR_RNDN);
mpfr_abs(t3,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,t3,MPFR_RNDN);
mpfr_add(t3,t1,t2,MPFR_RNDN);
mpfr_set(Xin,t3,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,33,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 33 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(abs((Xxr*Xxr))*(Xxr*dxa)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxa)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dya)))+((2*(abs((Xxi*Xxi))*(Xxi*dya)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))))));
dxbn=((2*(abs((Xxr*Xxr))*(Xxr*dxb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dxb)))+((2*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-2*(abs((Xxr*Xxr))*(Xxi*dyb)))+((2*(abs((Xxi*Xxi))*(Xxi*dyb)))+((-2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi)))))))+((-2*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi)))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))))));
dyan=((2*(abs((Xxr*Xxr))*(Xxr*dya)))+((-2*(abs((Xxi*Xxi))*(Xxr*dya)))+((2*(abs((Xxr*Xxr))*(Xxi*dxa)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxa)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi)))))))+dba))))))))))));
dybn=((2*(abs((Xxr*Xxr))*(Xxr*dyb)))+((-2*(abs((Xxi*Xxi))*(Xxr*dyb)))+((2*(abs((Xxr*Xxr))*(Xxi*dxb)))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(abs((Xxi*Xxi))*(Xxi*dxb)))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi)))))))+dbb))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((Xi2*diffabs(Xi2,(((2*xi)*Xi)+xi2)))-(((4*Xi)*Xr)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))-(Xr2*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-(Xi2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+(Xr2*diffabs(Xr2,(((2*Xr)*xr)+xr2))))+((((2*xi)*Xi)+xi2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((4*(((Xi*xr)+(xi*Xr))+(xi*xr)))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))-((((2*Xr)*xr)+xr2)*abs(((Xi2+((2*xi)*Xi))+xi2))))-((((2*xi)*Xi)+xi2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+((((2*Xr)*xr)+xr2)*abs(((Xr2+((2*Xr)*xr))+xr2))))+cr);
xin=((((((((((2*Xr2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi))))+(((2*Xr)*Xi)*diffabs(Xr2,(((2*Xr)*xr)+xr2))))-(((2*Xr)*Xi)*diffabs(Xi2,(((2*xi)*Xi)+xi2))))-((2*Xi2)*diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))))+((2*(((2*Xr)*xr)+xr2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xr2+((2*Xr)*xr))+xr2))))-((2*(((Xr*xi)+(xr*Xi))+(xr*xi)))*abs(((Xi2+((2*xi)*Xi))+xi2))))-((2*(((2*xi)*Xi)+xi2))*abs(((((Xr*Xi)+(Xr*xi))+(xr*Xi))+(xr*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,34,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,34,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = (dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa)))))); \
        dybn = (dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xr,4,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,34,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 34 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,35,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,35,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = (dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya)))))); \
        dybn = (dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,35,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 35 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,36,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,36,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))); \
        dyan = (dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya)))))); \
        dybn = (dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_add(t0,t1,Cr,MPFR_RNDN);
mpfr_set(Xrn,t0,MPFR_RNDN);
mpfr_mul_ui(t0,Xi,4,MPFR_RNDN);
mpfr_mul(t1,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t1,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,36,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 36 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(((((((((((((((((((4*Xr2)*Xr)*xr)+((6*Xr2)*xr2))+(((4*Xr)*xr2)*xr))+(xr2*xr2))+(((4*Xi2)*Xi)*xi))+((6*Xi2)*xi2))+(((4*Xi)*xi2)*xi))+(xi2*xi2))-(((12*Xr2)*Xi)*xi))-((6*Xr2)*xi2))-(((12*Xr)*xr)*Xi2))-((((24*Xr)*xr)*Xi)*xi))-(((12*Xr)*xr)*xi2))-((6*xr2)*Xi2))-(((12*xr2)*Xi)*xi))-((6*xr2)*xi2))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,37,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,37,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = (dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa)))))); \
        dybn = (dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr,4,MPFR_RNDN);
mpfr_mul(t0,Xi,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xi,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,37,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 37 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxr*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxa))))));
dybn=(dbb+((4*(Xxr*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxi)))+(Xxi*(Xxr*Xxr))))*dxb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*xr)*abs(((((((((((-(Xi2)*Xi)-((3*xi)*Xi2))+(Xr2*Xi))+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi))))+((4*Xr)*diffabs(((-(Xi2)*Xi)+(Xr2*Xi)),(((((((((-3*xi)*Xi2)+(((2*xr)*Xr)*Xi))-((3*xi2)*Xi))+(xr2*Xi))+(xi*Xr2))+(((2*xr)*xi)*Xr))-(xi2*xi))+(xr2*xi)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,38,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,38,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = (dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya)))))); \
        dybn = (dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_sub(t2,Ci,t3,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,38,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 38 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(-4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((-4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))-((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,39,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,39,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.000001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa)))); \
        dxbn = ((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab)))); \
        dyan = (dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya)))))); \
        dybn = (dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xr2,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi2,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xr2,6,MPFR_RNDN);
mpfr_mul(t0,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t2,t0,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_add(t1,t0,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi,4,MPFR_RNDN);
mpfr_mul(t0,Xr,Xr2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_sub(t3,t0,t2,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t1,t2,MPFR_RNDN);
mpfr_add(t2,t3,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,39,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 39 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((4*(Xxi*(Xxi*(Xxi*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxa*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dya*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+daa))));
dxbn=((4*(Xxi*(Xxi*(Xxi*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((4*(Xxr*(Xxr*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxi*(Xxr*(dxb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+((-12*(Xxi*(Xxr*(Xxr*(dyb*sgn(((Xxi*(Xxi*(Xxi*Xxi)))+((-6*(Xxi*(Xxi*(Xxr*Xxr))))+(Xxr*(Xxr*(Xxr*Xxr)))))))))))+dab))));
dyan=(dba+((-4*(Xxi*(Xxi*(Xxi*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dya))))));
dybn=(dbb+((-4*(Xxi*(Xxi*(Xxi*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((-8*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+((12*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr)))))))))+(4*(abs(((-1*(Xxi*(Xxi*Xxr)))+(Xxr*(Xxr*Xxr))))*dyb))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=(diffabs((((Xr2*Xr2)+(Xi2*Xi2))-((6*Xr2)*Xi2)),((((((((((((((((((4*Xi2)*Xi)*xi)-(((12*Xi2)*xr)*Xr))+((6*Xi2)*xi2))-((6*Xi2)*xr2))-(((12*Xr2)*Xi)*xi))-((((24*Xr)*Xi)*xr)*xi))+(((4*xi2)*xi)*Xi))-(((12*xi)*Xi)*xr2))+(((4*Xr2)*Xr)*xr))-((6*Xr2)*xi2))+((6*Xr2)*xr2))-(((12*xi2)*Xr)*xr))+(((4*xr2)*xr)*Xr))+(xi2*xi2))-((6*xi2)*xr2))+(xr2*xr2)))+cr);
xin=((((4*Xi)*diffabs(((Xr2*Xr)-(Xr*Xi2)),((((((((-(xr)*Xi2)-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr))))+((4*xi)*abs(((((((((((-(Xr)*Xi2)-(xr*Xi2))-(((2*xi)*Xr)*Xi))-(((2*xr)*xi)*Xi))+(Xr2*Xr))+((3*xr)*Xr2))-(xi2*Xr))+((3*xr2)*Xr))-(xr*xi2))+(xr2*xr)))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,40,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,40,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dya))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dya))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxa))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxa))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxa))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa)))))))))))))))))))))))); \
        dxbn = ((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dyb))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dyb))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxb))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxb))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab)))))))))))))))))))))))); \
        dyan = ((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dya))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dya))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+dba)))))))))))))))))))))))); \
        dybn = ((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dyb))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dyb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+dbb)))))))))))))))))))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_mul(t0,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t0,MPFR_RNDN);
mpfr_mul_ui(t0,t1,3,MPFR_RNDN);
mpfr_mul(t1,t0,Xi2,MPFR_RNDN);
mpfr_mul(t0,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t1,Xi2,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr2,MPFR_RNDN);
mpfr_mul(t2,t0,Xr,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_add(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul_ui(t1,Xi2,3,MPFR_RNDN);
mpfr_mul(t2,t1,Xi,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul(t1,t2,t0,MPFR_RNDN);
mpfr_mul(t0,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t2,t0,MPFR_RNDN);
mpfr_mul(t0,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t0,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,9,MPFR_RNDN);
mpfr_mul(t1,t2,Xi2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr,MPFR_RNDN);
mpfr_sub(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xr,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,9,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t0,Xr2,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xr2,Xr,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t1,3,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_add(t1,t0,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,t0,3,MPFR_RNDN);
mpfr_mul(t0,t2,Xr,MPFR_RNDN);
mpfr_mul(t2,t0,Xi2,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_mul(t2,Xi2,Xi,MPFR_RNDN);
mpfr_abs(t1,t2,MPFR_RNDN);
mpfr_mul(t2,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t2,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_mul(t1,Xi,Xr2,MPFR_RNDN);
mpfr_abs(t0,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t0,3,MPFR_RNDN);
mpfr_mul(t0,t1,Xr2,MPFR_RNDN);
mpfr_mul(t1,t0,Xr,MPFR_RNDN);
mpfr_add(t0,t2,t1,MPFR_RNDN);
mpfr_add(t1,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t1,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,40,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 40 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dya))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dya))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dya*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxa))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxa))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxa))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+daa))))))))))))))))))))))));
dxbn=((3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dyb))))+((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxr)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dyb))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dyb*sgn(Xxi))))))))))+((-6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dxb))))+((-6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dxb))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dxb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((-9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+dab))))))))))))))))))))))));
dyan=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dya))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxa))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dya))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxa))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dya))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxa))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dya))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dya))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxa))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxa))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxa))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dya))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr))))))))))+dba))))))))))))))))))))))));
dybn=((3*(abs((Xxr*(Xxr*Xxr)))*(Xxr*(Xxr*dyb))))+((-3*(abs((Xxi*(Xxi*Xxi)))*(Xxr*(Xxr*dxb))))+((3*(sgn(Xxi)*(sgn(Xxr)*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-3*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxi*dyb))))+((3*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxi*dxb))))+((-3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxi))))))))))+((-3*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((3*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr))))))))))+((6*(abs((Xxi*(Xxi*Xxi)))*(Xxi*(Xxr*dyb))))+((6*(abs((Xxr*(Xxr*Xxr)))*(Xxi*(Xxr*dxb))))+((6*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr))))))))))+((6*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxi*Xxr)))*(Xxr*(Xxr*dyb))))+((9*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxi*dyb))))+((9*(abs((Xxi*(Xxr*Xxr)))*(Xxr*(Xxr*dxb))))+((9*(sgn(Xxr)*(sgn(Xxr)*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-9*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxi*dxb))))+((-9*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxi))))))))))+((-9*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+((-18*(abs((Xxi*(Xxi*Xxr)))*(Xxi*(Xxr*dxb))))+((-18*(abs((Xxi*(Xxr*Xxr)))*(Xxi*(Xxr*dyb))))+((-18*(sgn(Xxi)*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr))))))))))+((-18*(sgn(Xxi)*(sgn(Xxr)*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr))))))))))+dbb))))))))))))))))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((((((((((((((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xi2*Xi))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xi2*Xi)))+((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr*Xi2)))-((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr*Xi2)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xi)))-((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xr)))+(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xr2*Xr)))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))+((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))-((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+cr);
xin=((((((((((((((((((3*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xi2*Xi))-(diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr)))*(Xi2*Xi)))-((9*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr*Xi2)))-((9*diffabs((Xr*Xi2),(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(Xr2*Xi)))+((3*diffabs((Xr2*Xr),((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))*(Xr2*Xi)))+((3*diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))*(Xr*Xi2)))-(diffabs((Xi2*Xi),((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi)))*(Xr2*Xr)))+((3*diffabs((Xr2*Xi),(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(Xr2*Xr)))+((3*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-(abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr)))*((((3*Xi2)*xi)+((3*Xi)*xi2))+(xi2*xi))))-((9*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-((9*abs(((((((Xr*Xi2)+(((2*Xr)*Xi)*xi))+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xr2*Xr)+((3*Xr2)*xr))+((3*Xr)*xr2))+(xr2*xr))))*(((((Xr2*xi)+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))+((3*abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi))))*(((((((2*Xr)*Xi)*xi)+(Xr*xi2))+(xr*Xi2))+(((2*xr)*Xi)*xi))+(xr*xi2))))-(abs(((((Xi2*Xi)+((3*Xi2)*xi))+((3*Xi)*xi2))+(xi2*xi)))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+((3*abs(((((((Xr2*Xi)+(Xr2*xi))+(((2*Xr)*xr)*Xi))+(((2*Xr)*xr)*xi))+(xr2*Xi))+(xr2*xi))))*((((3*Xr2)*xr)+((3*Xr)*xr2))+(xr2*xr))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,41,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,41,2)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = (daa+((2*(Xxr*dxa))+((-2*(Xxi*dya))+(-1*(dxa*sgn(Xxr)))))); \
        dxbn = (dab+((2*(Xxr*dxb))+((-2*(Xxi*dyb))+(-1*(dxb*sgn(Xxr)))))); \
        dyan = (dba+((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+(-1*(dya*sgn(Xxi)))))); \
        dybn = (dbb+((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+(-1*(dyb*sgn(Xxi)))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t1,Xr,MPFR_RNDN);
mpfr_sub(t2,t0,t1,MPFR_RNDN);
mpfr_add(t1,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t1,MPFR_RNDN);
mpfr_mul(t1,Xr,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul_ui(t1,t2,2,MPFR_RNDN);
mpfr_abs(t2,Xi,MPFR_RNDN);
mpfr_sub(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,41,2)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 41 && m_nPower == 2)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=(daa+((2*(Xxr*dxa))+((-2*(Xxi*dya))+(-1*(dxa*sgn(Xxr))))));
dxbn=(dab+((2*(Xxr*dxb))+((-2*(Xxi*dyb))+(-1*(dxb*sgn(Xxr))))));
dyan=(dba+((2*(sgn(Xxi)*(Xxi*(dxa*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dya*sgn(Xxr)))))+(-1*(dya*sgn(Xxi))))));
dybn=(dbb+((2*(sgn(Xxi)*(Xxi*(dxb*sgn(Xxr)))))+((2*(sgn(Xxi)*(Xxr*(dyb*sgn(Xxr)))))+(-1*(dyb*sgn(Xxi))))));
}

{xrn=((((xr*((2*Xr)+xr))-(xi*(xi+(2*Xi))))-diffabs(Xr,xr))+cr);
xin=(((diffabs((Xr*Xi),(((Xr*xi)+(xr*Xi))+(xr*xi)))*2)-diffabs(Xi,xi))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,42,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,42,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^3) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,42,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 42 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((3*(Xxr*(Xxr*dxa)))+((-3*(Xxi*(Xxi*dxa)))+((-6*(Xxi*(Xxr*dya)))+daa)))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((3*(Xxr*(Xxr*dxb)))+((-3*(Xxi*(Xxi*dxb)))+((-6*(Xxi*(Xxr*dyb)))+dab)))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((3*(Xxr*(Xxr*dya)))+((-3*(Xxi*(Xxi*dya)))+((6*(Xxi*(Xxr*dxa)))+dba)))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((3*(Xxr*(Xxr*dyb)))+((-3*(Xxi*(Xxi*dyb)))+((6*(Xxi*(Xxr*dxb)))+dbb)))))));
}

{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))+((3*X2)*x))+((3*X)*x2))+(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,43,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,43,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-3*(Xxr*(Xxr*dxa)))+((3*(Xxi*(Xxi*dxa)))+((6*(Xxi*(Xxr*dya)))+daa))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-3*(Xxr*(Xxr*dxb)))+((3*(Xxi*(Xxi*dxb)))+((6*(Xxi*(Xxr*dyb)))+dab))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^3) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,43,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 43 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-3*(Xxr*(Xxr*dxa)))+((3*(Xxi*(Xxi*dxa)))+((6*(Xxi*(Xxr*dya)))+daa)))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-3*(Xxr*(Xxr*dxb)))+((3*(Xxi*(Xxi*dxb)))+((6*(Xxi*(Xxr*dyb)))+dab)))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((-6*(Xxi*(Xxr*dxa)))+dba)))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((-6*(Xxi*(Xxr*dxb)))+dbb)))))));
}

{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((A*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,44,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,44,3)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-3*(Xxr*(Xxr*dxa)))+((3*(Xxi*(Xxi*dxa)))+((4*(Xxr*dxa))+((-4*(Xxi*dya))+((6*(Xxi*(Xxr*dya)))+daa))))); \
        dxbn = ((-3*(Xxr*(Xxr*dxb)))+((3*(Xxi*(Xxi*dxb)))+((4*(Xxr*dxb))+((-4*(Xxi*dyb))+((6*(Xxi*(Xxr*dyb)))+dab))))); \
        dyan = ((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((4*(Xxi*dxa))+((4*(Xxr*dya))+((-6*(Xxi*(Xxr*dxa)))+dba))))); \
        dybn = ((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((4*(Xxi*dxb))+((4*(Xxr*dyb))+((-6*(Xxi*(Xxr*dxb)))+dbb))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = 2 * (X^2) - (X^3) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,44,3)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 44 && m_nPower == 3)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-3*(Xxr*(Xxr*dxa)))+((3*(Xxi*(Xxi*dxa)))+((4*(Xxr*dxa))+((-4*(Xxi*dya))+((6*(Xxi*(Xxr*dya)))+daa)))));
dxbn=((-3*(Xxr*(Xxr*dxb)))+((3*(Xxi*(Xxi*dxb)))+((4*(Xxr*dxb))+((-4*(Xxi*dyb))+((6*(Xxi*(Xxr*dyb)))+dab)))));
dyan=((-3*(Xxr*(Xxr*dya)))+((3*(Xxi*(Xxi*dya)))+((4*(Xxi*dxa))+((4*(Xxr*dya))+((-6*(Xxi*(Xxr*dxa)))+dba)))));
dybn=((-3*(Xxr*(Xxr*dyb)))+((3*(Xxi*(Xxi*dyb)))+((4*(Xxi*dxb))+((4*(Xxr*dyb))+((-6*(Xxi*(Xxr*dxb)))+dbb)))));
}

{const complex<T> X2 = X * X;
const complex<T> x2 = x * x;
xn=(((((2*(((2*X)*x)+x2))-((3*X2)*x))-((3*X)*x2))-(x2*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,45,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,45,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa)))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+dba)))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+dbb)))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^4) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,45,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 45 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((4*(Xxi*(Xxi*(Xxi*dya))))+((4*(Xxr*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dya))))+daa))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((4*(Xxi*(Xxi*(Xxi*dyb))))+((4*(Xxr*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dyb))))+dab))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((4*(Xxr*(Xxr*(Xxr*dya))))+((-4*(Xxi*(Xxi*(Xxi*dxa))))+((12*(Xxi*(Xxr*(Xxr*dxa))))+((-12*(Xxi*(Xxi*(Xxr*dya))))+dba))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((4*(Xxr*(Xxr*(Xxr*dyb))))+((-4*(Xxi*(Xxi*(Xxi*dxb))))+((12*(Xxi*(Xxr*(Xxr*dxb))))+((-12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))))))));
}

{const complex<T> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))+((4*(X^3))*x))+((6*(X^2))*x2))+(((4*X)*x2)*x))+(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,46,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,46,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-4*(Xxi*(Xxi*(Xxi*dya))))+((-4*(Xxr*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dxa))))+((12*(Xxi*(Xxr*(Xxr*dya))))+daa)))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-4*(Xxi*(Xxi*(Xxi*dyb))))+((-4*(Xxr*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dxb))))+((12*(Xxi*(Xxr*(Xxr*dyb))))+dab)))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba)))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb)))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^4) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,46,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 46 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-4*(Xxi*(Xxi*(Xxi*dya))))+((-4*(Xxr*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dxa))))+((12*(Xxi*(Xxr*(Xxr*dya))))+daa))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-4*(Xxi*(Xxi*(Xxi*dyb))))+((-4*(Xxr*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dxb))))+((12*(Xxi*(Xxr*(Xxr*dyb))))+dab))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-4*(Xxr*(Xxr*(Xxr*dya))))+((4*(Xxi*(Xxi*(Xxi*dxa))))+((-12*(Xxi*(Xxr*(Xxr*dxa))))+((12*(Xxi*(Xxi*(Xxr*dya))))+dba))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-4*(Xxr*(Xxr*(Xxr*dyb))))+((4*(Xxi*(Xxi*(Xxi*dxb))))+((-12*(Xxi*(Xxr*(Xxr*dxb))))+((12*(Xxi*(Xxi*(Xxr*dyb))))+dbb))))))));
}

{const complex<T> x2 = x * x;
xn=((((((A*(((2*X)*x)+x2))-((4*(X^3))*x))-((6*(X^2))*x2))-(((4*X)*x2)*x))-(x2^2))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,47,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,47,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa))))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab))))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^5) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,47,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 47 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((-30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))))))));
}

{const complex<T> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))+((5*(X^4))*x))+((10*(X^3))*x2))+(((10*(X^2))*x2)*x))+((5*X)*(x2^2)))+((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,48,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,48,5)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa))))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab))))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba))))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb))))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^5) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,48,5)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 48 && m_nPower == 5)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dxa)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dya)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dxa)))))+daa)))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dxb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxi*(Xxi*(Xxr*dyb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dxb)))))+dab)))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dya)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dya)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxa)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxa)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dya)))))+dba)))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-5*(Xxi*(Xxi*(Xxi*(Xxi*dyb)))))+((-5*(Xxr*(Xxr*(Xxr*(Xxr*dyb)))))+((-20*(Xxi*(Xxr*(Xxr*(Xxr*dxb)))))+((20*(Xxi*(Xxi*(Xxi*(Xxr*dxb)))))+((30*(Xxi*(Xxi*(Xxr*(Xxr*dyb)))))+dbb)))))))));
}

{const complex<T> x2 = x * x;
xn=(((((((A*(((2*X)*x)+x2))-((5*(X^4))*x))-((10*(X^3))*x2))-(((10*(X^2))*x2)*x))-((5*X)*(x2^2)))-((x2*x2)*x))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,49,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,49,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dya))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dya))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxa))))))+daa)))))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dyb))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dyb))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxb))))))+dab)))))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxa))))))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dya))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dya))))))+dba)))))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxb))))))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dyb))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dyb))))))+dbb)))))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) + (X^6) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{const complex<T> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,49,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 49 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dya))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dya))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxa))))))+daa))))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dyb))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dyb))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxb))))))+dab))))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxa))))))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dya))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dya))))))+dba))))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxb))))))+((6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dyb))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dyb))))))+dbb))))))))));
}

{const complex<T> x2 = x * x;
xn=((((((((A*(((2*X)*x)+x2))+((6*(X^5))*x))+((15*(X^4))*x2))+((20*(X^3))*(x2*x)))+((15*(X^2))*(x2^2)))+((6*X)*((x2*x2)*x)))+(x2^3))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,50,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,50,6)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

    complex<CFixedFloat> C, A, X, Xn;
    mpfr_set(C.m_r.m_f.backend().data(), Cr, MPFR_RNDN);
    mpfr_set(C.m_i.m_f.backend().data(), Ci, MPFR_RNDN);
    mpfr_set(A.m_r.m_f.backend().data(), Ar, MPFR_RNDN);
    mpfr_set(A.m_i.m_f.backend().data(), Ai, MPFR_RNDN);


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
        const complex<T> Xx(Xxr, Xxi), A(g_FactorAR, g_FactorAI); \
 \
        dxan = ((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dya))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dya))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxa))))))+daa)))))))))); \
        dxbn = ((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dyb))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dyb))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxb))))))+dab)))))))))); \
        dyan = ((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxa))))))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dya))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dya))))))+dba)))))))))); \
        dybn = ((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxb))))))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dyb))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dyb))))))+dbb)))))))))); \
       \
       \


for (i = 0; i < nMaxIter && !m_bStop; i++)
      {
        mpfr_set(X.m_r.m_f.backend().data(), Xr, MPFR_RNDN);
        mpfr_set(X.m_i.m_f.backend().data(), Xi, MPFR_RNDN);
        {
          
        Xn = A * (X^2) - (X^6) + C;
      
          DLOOP
        }
        mpfr_set(Xrn, Xn.m_r.m_f.backend().data(), MPFR_RNDN);
        mpfr_set(Xin, Xn.m_i.m_f.backend().data(), MPFR_RNDN);
LOOP  }
#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;
{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,50,6)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 50 && m_nPower == 6)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

      const complex<T> X = {Xr, Xi}, x = {xr, xi}, Xx = {Xxr, Xxi};
      complex<T> xn;
      (void) X; (void) x; (void) Xx;

{dxan=((-2*(Xxr*(dya*g_FactorAI)))+((2*(Xxr*(dxa*g_FactorAR)))+((-2*(Xxi*(dxa*g_FactorAI)))+((-2*(Xxi*(dya*g_FactorAR)))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dya))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxa))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dya))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxa))))))+daa))))))))));
dxbn=((-2*(Xxr*(dyb*g_FactorAI)))+((2*(Xxr*(dxb*g_FactorAR)))+((-2*(Xxi*(dxb*g_FactorAI)))+((-2*(Xxi*(dyb*g_FactorAR)))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dyb))))))+((30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dxb))))))+((-60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dyb))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dxb))))))+dab))))))))));
dyan=((2*(Xxr*(dxa*g_FactorAI)))+((2*(Xxr*(dya*g_FactorAR)))+((-2*(Xxi*(dya*g_FactorAI)))+((2*(Xxi*(dxa*g_FactorAR)))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxa))))))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dya))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dya))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxa))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dya))))))+dba))))))))));
dybn=((2*(Xxr*(dxb*g_FactorAI)))+((2*(Xxr*(dyb*g_FactorAR)))+((-2*(Xxi*(dyb*g_FactorAI)))+((2*(Xxi*(dxb*g_FactorAR)))+((-6*(Xxi*(Xxi*(Xxi*(Xxi*(Xxi*dxb))))))+((-6*(Xxr*(Xxr*(Xxr*(Xxr*(Xxr*dyb))))))+((-30*(Xxi*(Xxi*(Xxi*(Xxi*(Xxr*dyb))))))+((-30*(Xxi*(Xxr*(Xxr*(Xxr*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxi*(Xxr*(Xxr*dxb))))))+((60*(Xxi*(Xxi*(Xxr*(Xxr*(Xxr*dyb))))))+dbb))))))))));
}

{xn=((((((((A*(((2*X)*x)+(x^2)))-((6*(X^5))*x))-((15*(X^4))*(x^2)))-((20*(X^3))*(x^3)))-((15*(X^2))*(x^4)))-((6*X)*(x^5)))-(x^6))+c);
}
      xrn = xn.m_r; xin = xn.m_i;


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



template <typename T>
bool FORMULA(reference,51,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  )
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);


#define LOOP \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP
mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP

#undef DLOOP


#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(reference,51,4)
  ( const int m_nFractalType, const int m_nPower
  , T *m_db_dxr, T *m_db_dxi, double *m_db_z
  , int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter
  , const CFixedFloat &Cr0, const CFixedFloat &Ci0
  , const double g_SeedR, const double g_SeedI
  , const double g_FactorAR, const double g_FactorAI
  , const double terminate, const double g_real, const double g_imag
  , const bool m_bGlitchLowTolerance
  , int &antal, double &test1, double &test2
  , T &dr0, T &di0
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    bool stored = false;
    double old_absval = 0;
    double abs_val = 0;
    m_nGlitchIter = m_nMaxIter + 1;
    int nMaxIter = m_nMaxIter;
    int i;
    double glitch = 0.0001;
    if (m_bGlitchLowTolerance) {
      glitch = sqrt(glitch);
    }
    mp_bitcnt_t bits = mpfr_get_prec(Cr0.m_f.backend().data());
    mpfr_t Cr; mpfr_init2(Cr, bits); mpfr_set(Cr, Cr0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Ci; mpfr_init2(Ci, bits); mpfr_set(Ci, Ci0.m_f.backend().data(), MPFR_RNDN);
    mpfr_t Xr; mpfr_init2(Xr, bits); mpfr_set_d(Xr, g_SeedR, MPFR_RNDN);
    mpfr_t Xi; mpfr_init2(Xi, bits); mpfr_set_d(Xi, g_SeedI, MPFR_RNDN);
    T Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN);
    T Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN);
    mpfr_t Xr2; mpfr_init2(Xr2, bits); mpfr_sqr(Xr2, Xr, MPFR_RNDN);
    mpfr_t Xi2; mpfr_init2(Xi2, bits); mpfr_sqr(Xi2, Xi, MPFR_RNDN);
    mpfr_t Xrn; mpfr_init2(Xrn, bits);
    mpfr_t Xin; mpfr_init2(Xin, bits);
    mpfr_t Ar; mpfr_init2(Ar, bits); mpfr_set_d(Ar, g_FactorAR, MPFR_RNDN);
    mpfr_t Ai; mpfr_init2(Ai, bits); mpfr_set_d(Ai, g_FactorAI, MPFR_RNDN);

    T dxa = daa, dxb = dab, dya = dba, dyb = dbb;
    T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;


#define LOOP \
 \
    dxa = dxan; dxb = dxbn; dya = dyan, dyb = dybn; \
 \
      mpfr_set(Xr, Xrn, MPFR_RNDN); \
      mpfr_set(Xi, Xin, MPFR_RNDN); \
      mpfr_sqr(Xr2, Xr, MPFR_RNDN); \
      mpfr_sqr(Xi2, Xi, MPFR_RNDN); \
      m_nRDone++; \
      Xrd = mpfr_get(Xr, T(0.0), MPFR_RNDN); \
      Xid = mpfr_get(Xi, T(0.0), MPFR_RNDN); \
      old_absval = abs_val; \
      abs_val = double(g_real * Xrd * Xrd + g_imag * Xid * Xid); \
      const double Xz = abs_val * glitch; \
      m_db_dxr[i] = Xrd; \
      m_db_dxi[i] = Xid; \
      m_db_z[i] = Xz; \
      if (abs_val >= 4) \
      { \
        if (terminate == 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
      } \
      if (abs_val >= terminate){ \
        if (terminate > 4 && !stored) \
        { \
          stored = true; \
          antal = i; \
          test1 = abs_val; \
          test2 = old_absval; \
        } \
        if (nMaxIter == m_nMaxIter){ \
          nMaxIter = i + 3; \
          if (nMaxIter > m_nMaxIter) \
            nMaxIter = m_nMaxIter; \
          m_nGlitchIter = nMaxIter; \
        } \
      }


#define DLOOP \
 \
        const T Xxr = Xrd; (void) Xxr; \
        const T Xxi = Xid; (void) Xxi; \
 \
        dxan = ((2*(Xxr*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxa)))+((-2*(Xxi*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dya)))+((2*(Xxi*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa)))))))))); \
        dxbn = ((2*(Xxr*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxb)))+((-2*(Xxi*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dyb)))+((2*(Xxi*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab)))))))))); \
        dyan = ((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba)))))))))); \
        dybn = ((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb)))))))))); \
       \
       \


mpfr_t t0; mpfr_init2(t0, bits);
mpfr_t t1; mpfr_init2(t1, bits);
mpfr_t t2; mpfr_init2(t2, bits);
mpfr_t t3; mpfr_init2(t3, bits);
for (i = 0; i < nMaxIter && !m_bStop; i++) { DLOOP
mpfr_sub(t0,Xr2,Xi2,MPFR_RNDN);
mpfr_sub(t1,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t0,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t0,t2,Xi,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t3,MPFR_RNDN);
mpfr_mul(t3,t0,t2,MPFR_RNDN);
mpfr_sub(t2,t1,t3,MPFR_RNDN);
mpfr_add(t3,t2,Cr,MPFR_RNDN);
mpfr_set(Xrn,t3,MPFR_RNDN);
mpfr_sub(t3,Xr2,Xi2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t1,t2,Xi,MPFR_RNDN);
mpfr_abs(t2,t1,MPFR_RNDN);
mpfr_mul(t1,t3,t2,MPFR_RNDN);
mpfr_mul_ui(t2,Xr,2,MPFR_RNDN);
mpfr_mul(t3,t2,Xi,MPFR_RNDN);
mpfr_sub(t2,Xr2,Xi2,MPFR_RNDN);
mpfr_abs(t0,t2,MPFR_RNDN);
mpfr_mul(t2,t3,t0,MPFR_RNDN);
mpfr_add(t0,t1,t2,MPFR_RNDN);
mpfr_add(t2,t0,Ci,MPFR_RNDN);
mpfr_set(Xin,t2,MPFR_RNDN);
LOOP }
mpfr_clear(t0);
mpfr_clear(t1);
mpfr_clear(t2);
mpfr_clear(t3);
#undef DLOOP



#undef LOOP
    mpfr_clear(Cr);
    mpfr_clear(Ci);
    mpfr_clear(Xr);
    mpfr_clear(Xi);
    mpfr_clear(Xr2);
    mpfr_clear(Xi2);
    mpfr_clear(Xrn);
    mpfr_clear(Xin);
    mpfr_clear(Ar);
    mpfr_clear(Ai);

    dr0 = (Xrd * dxa + Xid * dya) / sqrt(test1);
    di0 = (Xrd * dxb + Xid * dyb) / sqrt(test1);

    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  )
{
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {
        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;
      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;



{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


      xr = xrn;
      xi = xin;
    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;
    return true;
  }
  return false;
}

template <typename T>
bool FORMULA(perturbation,51,4)
  ( int m_nFractalType, int m_nPower
  , const T *m_db_dxr, const T *m_db_dxi, const double *m_db_z
  , int &antal0, double &test10, double &test20, int &bGlitch
  , double m_nBailout2, const int nMaxIter
  , const int m_bNoGlitchDetection, const double g_real, const double g_imag
  , const double g_FactorAR, const double g_FactorAI
  , T &xr0, T &xi0
  , const T &cr, const T &ci
  , T &dr0, T &di0
  , const T &e, const T &h
  , const T &daa, const T &dab, const T &dba, const T &dbb
  )
{
  (void) dr0; // -Wunused-parameter
  (void) di0; // -Wunused-parameter
  (void) h; // -Wunused-parameter
  (void) e; // -Wunused-parameter
  (void) daa; // -Wunused-parameter
  (void) dab; // -Wunused-parameter
  (void) dba; // -Wunused-parameter
  (void) dbb; // -Wunused-parameter
  if (m_nFractalType == 51 && m_nPower == 4)
  {
    const complex<T> A = { g_FactorAR, g_FactorAI };
    const complex<T> c = { cr, ci };
    (void) A; // -Wunused-variable
    (void) c; // -Wunused-variable
    int antal = antal0;
    double test1 = test10;
    double test2 = test20;
    T xr = xr0;
    T xi = xi0;
    (void) dr0; // -Wunused-parameter
    (void) di0; // -Wunused-parameter

    T dxa = dr0, dxb = -di0, dya = di0, dyb = dr0;

    T Xxr = 0;
    T Xxi = 0;
    for (; antal < nMaxIter; antal++)
    {
      const T Xr = m_db_dxr[antal];
      const T Xi = m_db_dxi[antal];
      const double Xz = m_db_z[antal];
      Xxr = Xr + xr;
      Xxi = Xi + xi;
      test2 = test1;
      test1 = double(g_real * Xxr * Xxr + g_imag * Xxi * Xxi);
      if (test1 < Xz)
      {

        bGlitch = true;
        if (! m_bNoGlitchDetection)
          break;

      }
      if (test1 > m_nBailout2)
      {
        break;
      }
      T xrn, xin;


      T dxan = 0, dxbn = 0, dyan = 0, dybn = 0;

{dxan=((2*(Xxr*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxa)))+((-2*(Xxi*(Xxi*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dya)))+((2*(Xxi*(Xxi*(Xxi*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxr*dya)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxa*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+daa))))))))));
dxbn=((2*(Xxr*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dxb)))+((-2*(Xxi*(Xxi*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(Xxi*(Xxr*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dyb)))+((2*(Xxi*(Xxi*(Xxi*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(abs((Xxi*Xxr))*(Xxi*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxr*dyb)))+((-4*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dxb*sgn(Xxr)))))))+((-4*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+dab))))))))));
dyan=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxa)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dya)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxa*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dya*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxa*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dya*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxa)))+((-4*(abs((Xxi*Xxr))*(Xxi*dya)))+((4*(Xxi*(Xxr*(Xxr*(dxa*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dya*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dba))))))))));
dybn=((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxi*dxb)))+((2*(abs(((-1*(Xxi*Xxi))+(Xxr*Xxr)))*(Xxr*dyb)))+((2*(sgn(Xxi)*(Xxi*(Xxr*(Xxr*(dxb*sgn(Xxr)))))))+((2*(sgn(Xxi)*(Xxr*(Xxr*(Xxr*(dyb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxi*(dxb*sgn(Xxr)))))))+((-2*(sgn(Xxi)*(Xxi*(Xxi*(Xxr*(dyb*sgn(Xxr)))))))+((4*(abs((Xxi*Xxr))*(Xxr*dxb)))+((-4*(abs((Xxi*Xxr))*(Xxi*dyb)))+((4*(Xxi*(Xxr*(Xxr*(dxb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+((-4*(Xxi*(Xxi*(Xxr*(dyb*sgn(((-1*(Xxi*Xxi))+(Xxr*Xxr))))))))+dbb))))))))));
}

{const T Xr2 = Xr * Xr;
const T Xi2 = Xi * Xi;
const T xr2 = xr * xr;
const T xi2 = xi * xi;
xrn=((((((Xr2-Xi2)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((Xr2+((2*Xr)*xr))+xr2)-Xi2)-((2*Xi)*xi))-xi2))))-(((2*Xr)*Xi)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi)))))-(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+cr);
xin=((((((Xr2-Xi2)*diffabs(((2*Xr)*Xi),((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))))+((((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2)*abs((((((2*Xr)*Xi)+((2*Xr)*xi))+((2*xr)*Xi))+((2*xr)*xi)))))+(((2*Xr)*Xi)*diffabs((Xr2-Xi2),(((((2*Xr)*xr)+xr2)-((2*Xi)*xi))-xi2))))+(((((2*Xr)*xi)+((2*xr)*Xi))+((2*xr)*xi))*abs((((((Xr2-Xi2)+((2*Xr)*xr))+xr2)-((2*Xi)*xi))-xi2))))+ci);
}


      xr = xrn;
      xi = xin;

      dxa = dxan; dxb = dxbn; dya = dyan; dyb = dybn;

    }
    antal0 = antal;
    test10 = test1;
    test20 = test2;
    xr0 = xr;
    xi0 = xi;

    dr0 = (Xxr * dxa + Xxi * dya) / sqrt(test1);
    di0 = (Xxr * dxb + Xxi * dyb) / sqrt(test1);

    return true;
  }
  return false;
}



bool reference_double(const int m_nFractalType, const int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,0,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,0,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,0,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference,0,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference,0,7)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference,0,8)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference,0,9)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference,0,10)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,1,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,1,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,1,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,2,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,2,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,2,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,3,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,3,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,3,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,4,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,4,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,4,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}

bool reference_long_double(const int m_nFractalType, const int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,0,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,0,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,0,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference,0,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference,0,7)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference,0,8)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference,0,9)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference,0,10)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,1,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,1,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,1,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,2,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,2,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,2,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,3,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,3,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,3,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,4,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,4,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,4,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}

bool reference_floatexp(const int m_nFractalType, const int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,0,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,0,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,0,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 6:
          return FORMULA(reference,0,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 7:
          return FORMULA(reference,0,7)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 8:
          return FORMULA(reference,0,8)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 9:
          return FORMULA(reference,0,9)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 10:
          return FORMULA(reference,0,10)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,1,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,1,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,1,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,2,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,2,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,2,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,3,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,3,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,3,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 3:
          return FORMULA(reference,4,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 4:
          return FORMULA(reference,4,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
        case 5:
          return FORMULA(reference,4,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2);
      
      }
      break;
  
  }
  return false;
}

bool reference_double(const int m_nFractalType, const int m_nPower, double *m_db_dxr, double *m_db_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2, double &dr, double &di, const double &daa, const double &dab, const double &dba, const double &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,0,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,0,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,0,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(reference,0,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(reference,0,7)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(reference,0,8)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(reference,0,9)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(reference,0,10)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,1,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,1,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,1,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,2,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,2,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,2,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,3,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,3,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,3,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,4,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,4,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,4,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

bool reference_long_double(const int m_nFractalType, const int m_nPower, long double *m_ldxr, long double *m_ldxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2, long double &dr, long double &di, const long double &daa, const long double &dab, const long double &dba, const long double &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,0,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,0,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,0,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(reference,0,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(reference,0,7)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(reference,0,8)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(reference,0,9)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(reference,0,10)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,1,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,1,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,1,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,2,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,2,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,2,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,3,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,3,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,3,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,4,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,4,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,4,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<long double>(m_nFractalType, m_nPower, m_ldxr, m_ldxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

bool reference_floatexp(const int m_nFractalType, const int m_nPower, floatexp *m_dxr, floatexp *m_dxi, double *m_db_z, int &m_bStop, int &m_nRDone, int &m_nGlitchIter, int &m_nMaxIter, const CFixedFloat &Cr, const CFixedFloat &Ci, const double g_SeedR, const double g_SeedI, const double g_FactorAR, const double g_FactorAI, const double terminate, const double g_real, const double g_imag, const bool m_bGlitchLowTolerance, int &antal, double &test1, double &test2, floatexp &dr, floatexp &di, const floatexp &daa, const floatexp &dab, const floatexp &dba, const floatexp &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,0,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,0,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,0,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,0,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(reference,0,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(reference,0,7)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(reference,0,8)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(reference,0,9)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(reference,0,10)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,1,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,1,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,1,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,1,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,2,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,2,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,2,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,2,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,3,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,3,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,3,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,3,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,4,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(reference,4,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(reference,4,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(reference,4,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,5,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,6,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,7,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,8,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,9,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,10,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,11,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,12,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,13,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,14,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,15,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,16,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,17,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,18,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,19,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,20,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,21,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,22,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,23,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,24,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,25,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,26,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,27,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,28,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,29,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,30,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,31,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,32,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,33,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,34,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,35,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,36,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,37,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,38,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,39,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,40,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(reference,41,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,42,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,43,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(reference,44,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,45,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,46,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,47,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(reference,48,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,49,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(reference,50,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(reference,51,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, m_bStop, m_nRDone, m_nGlitchIter, m_nMaxIter, Cr, Ci, g_SeedR, g_SeedI, g_FactorAR, g_FactorAI, terminate, g_real, g_imag, m_bGlitchLowTolerance, antal, test1, test2, dr, di, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_double(const int m_nFractalType, const int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, double &xr, double &xi, const double cr, const double ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,0,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,0,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,0,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation,0,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation,0,7)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation,0,8)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation,0,9)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation,0,10)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,1,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,1,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,1,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,2,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,2,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,2,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,3,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,3,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,3,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,4,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,4,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,4,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_long_double(const int m_nFractalType, const int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, long double &xr, long double &xi, const long double cr, const long double ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,0,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,0,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,0,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation,0,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation,0,7)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation,0,8)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation,0,9)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation,0,10)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,1,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,1,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,1,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,2,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,2,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,2,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,3,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,3,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,3,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,4,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,4,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,4,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_floatexp(const int m_nFractalType, const int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, floatexp &xr, floatexp &xi, const floatexp cr, const floatexp ci)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,0,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,0,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,0,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 6:
          return FORMULA(perturbation,0,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 7:
          return FORMULA(perturbation,0,7)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 8:
          return FORMULA(perturbation,0,8)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 9:
          return FORMULA(perturbation,0,9)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 10:
          return FORMULA(perturbation,0,10)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,1,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,1,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,1,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,2,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,2,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,2,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,3,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,3,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,3,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 3:
          return FORMULA(perturbation,4,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 4:
          return FORMULA(perturbation,4,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
        case 5:
          return FORMULA(perturbation,4,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_double(const int m_nFractalType, const int m_nPower, const double *m_db_dxr, const double *m_db_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, double &xr, double &xi, const double cr, const double ci, double &dr, double &di, const double &e, const double &h, const double &daa, const double &dab, const double &dba, const double &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,0,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,0,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,0,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(perturbation,0,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(perturbation,0,7)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(perturbation,0,8)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(perturbation,0,9)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(perturbation,0,10)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,1,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,1,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,1,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,2,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,2,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,2,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,3,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,3,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,3,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,4,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,4,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,4,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<double>(m_nFractalType, m_nPower, m_db_dxr, m_db_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_long_double(const int m_nFractalType, const int m_nPower, const long double *dxr, const long double *dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, long double &xr, long double &xi, const long double cr, const long double ci, long double &dr, long double &di, const long double &e, const long double &h, const long double &daa, const long double &dab, const long double &dba, const long double &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,0,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,0,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,0,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(perturbation,0,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(perturbation,0,7)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(perturbation,0,8)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(perturbation,0,9)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(perturbation,0,10)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,1,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,1,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,1,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,2,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,2,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,2,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,3,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,3,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,3,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,4,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,4,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,4,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<long double>(m_nFractalType, m_nPower, dxr, dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

bool perturbation_floatexp(const int m_nFractalType, const int m_nPower, const floatexp *m_dxr, const floatexp *m_dxi, const double *m_db_z, int &antal, double &test1, double &test2, int &bGlitch, const double m_nBailout2, const int nMaxIter, const int m_bNoGlitchDetection, const double g_real, const double g_imag, const double g_FactorAR, const double g_FactorAI, floatexp &xr, floatexp &xi, const floatexp cr, const floatexp ci, floatexp &dr, floatexp &di, const floatexp &e, const floatexp &h, const floatexp &daa, const floatexp &dab, const floatexp &dba, const floatexp &dbb)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,0,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,0,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,0,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,0,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 6:
          return FORMULA(perturbation,0,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 7:
          return FORMULA(perturbation,0,7)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 8:
          return FORMULA(perturbation,0,8)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 9:
          return FORMULA(perturbation,0,9)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 10:
          return FORMULA(perturbation,0,10)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,1,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,1,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,1,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,1,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,2,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,2,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,2,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,2,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,3,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,3,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,3,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,3,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,4,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 3:
          return FORMULA(perturbation,4,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 4:
          return FORMULA(perturbation,4,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
        case 5:
          return FORMULA(perturbation,4,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,5,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,6,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,7,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,8,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,9,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,10,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,11,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,12,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,13,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,14,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,15,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,16,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,17,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,18,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,19,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,20,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,21,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,22,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,23,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,24,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,25,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,26,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,27,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,28,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,29,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,30,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,31,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,32,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,33,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,34,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,35,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,36,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,37,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,38,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,39,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,40,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
      
        case 2:
          return FORMULA(perturbation,41,2)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,42,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,43,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
      
        case 3:
          return FORMULA(perturbation,44,3)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,45,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,46,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,47,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
      
        case 5:
          return FORMULA(perturbation,48,5)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,49,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
      
        case 6:
          return FORMULA(perturbation,50,6)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
      
        case 4:
          return FORMULA(perturbation,51,4)<floatexp>(m_nFractalType, m_nPower, m_dxr, m_dxi, m_db_z, antal, test1, test2, bGlitch, m_nBailout2, nMaxIter, m_bNoGlitchDetection, g_real, g_imag, g_FactorAR, g_FactorAI, xr, xi, cr, ci, dr, di, e, h, daa, dab, dba, dbb);
      
      }
      break;
  
  }
  return false;
}

void combo5_addstrings(HWND hWnd, const int IDC_COMBO5)
{
  
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbrot"); // 0
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Burning Ship"); // 1
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Buffalo"); // 2
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Celtic"); // 3
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar"); // 4
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Mandelbar Celtic"); // 5
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Mandelbrot"); // 6
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Burning Ship"); // 7
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Celtic"); // 8
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Perpendicular Buffalo"); // 9
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Burning Ship"); // 10
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Real"); // 11
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Partial BS Imag"); // 12
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Flying Squirrel (Buffalo Imag)"); // 13
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"Cubic Quasi Perpendicular"); // 14
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Imag"); // 15
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real"); // 16
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Burning Ship Partial Real Mbar"); // 17
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Imag"); // 18
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real"); // 19
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Burning Ship Partial Real Mbar"); // 20
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Buffalo Partial Imag"); // 21
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Mbar"); // 22
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Perpendicular"); // 23
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th False Quasi Heart"); // 24
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi Perpendicular"); // 25
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic False Quasi Heart"); // 26
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial"); // 27
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Burning Ship Partial Mbar"); // 28
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Celtic Mbar"); // 29
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Burning Ship (BS/Buffalo Hybrid)"); // 30
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Perpendicular"); // 31
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"5th Quasi Heart"); // 32
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 4th"); // 33
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Imag Quasi Perpendicular / Heart"); // 34
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Perpendicular"); // 35
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Real Quasi Heart"); // 36
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Imag Quasi Perpendicular / Heart"); // 37
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Perpendicular"); // 38
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"4th Celtic Real Quasi Heart"); // 39
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot 6th"); // 40
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"HPDZ Buffalo"); // 41
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 1: a*z^2+z^3+c"); // 42
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 2: a*z^2-z^3+c"); // 43
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 3: 2*z^2-z^3+c"); // 44
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 4: a*z^2+z^4+c"); // 45
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 5: a*z^2-z^4+c"); // 46
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 6: a*z^2+z^5+c"); // 47
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 7: a*z^2-z^5+c"); // 48
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 8: a*z^2+z^6+c"); // 49
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"TheRedshiftRider 9: a*z^2-z^6+c"); // 50
    SendDlgItemMessage(hWnd,IDC_COMBO5,CB_ADDSTRING,0,(LPARAM)"SimonBrot2 4th"); // 51
}

int validate_power_for_fractal_type(const int m_nFractalType, const int m_nPower)
{
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
        case 6: return 6;
      
        case 7: return 7;
      
        case 8: return 8;
      
        case 9: return 9;
      
        case 10: return 10;
      
      }
      break;
  
    // Burning Ship
    case 1:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Buffalo
    case 2:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Celtic
    case 3:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar
    case 4:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
        case 3: return 3;
      
        case 4: return 4;
      
        case 5: return 5;
      
      }
      break;
  
    // Mandelbar Celtic
    case 5:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Mandelbrot
    case 6:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Burning Ship
    case 7:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Celtic
    case 8:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Perpendicular Buffalo
    case 9:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // Cubic Quasi Burning Ship
    case 10:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Real
    case 11:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Partial BS Imag
    case 12:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // Cubic Quasi Perpendicular
    case 14:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // 4th Burning Ship Partial Imag
    case 15:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real
    case 16:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Buffalo Partial Imag
    case 21:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Mbar
    case 22:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Perpendicular
    case 23:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th False Quasi Heart
    case 24:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic False Quasi Heart
    case 26:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 5th Burning Ship Partial
    case 27:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Burning Ship Partial Mbar
    case 28:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Celtic Mbar
    case 29:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Perpendicular
    case 31:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // 5th Quasi Heart
    case 32:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // SimonBrot 4th
    case 33:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Perpendicular
    case 35:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Real Quasi Heart
    case 36:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // 4th Celtic Real Quasi Heart
    case 39:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // SimonBrot 6th
    case 40:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // HPDZ Buffalo
    case 41:
      switch (m_nPower)
      {
        default:
      
        case 2: return 2;
      
      }
      break;
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
      switch (m_nPower)
      {
        default:
      
        case 3: return 3;
      
      }
      break;
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
      switch (m_nPower)
      {
        default:
      
        case 5: return 5;
      
      }
      break;
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
      switch (m_nPower)
      {
        default:
      
        case 6: return 6;
      
      }
      break;
  
    // SimonBrot2 4th
    case 51:
      switch (m_nPower)
      {
        default:
      
        case 4: return 4;
      
      }
      break;
  
    default:
      return 2;
  }
}

void update_power_dropdown_for_fractal_type(HWND hWnd, const int IDC_COMBO3, const int m_nFractalType, const int m_nPower)
{
  SendDlgItemMessage(hWnd,IDC_COMBO3,CB_RESETCONTENT,0,0);
  int selected = 0;
  int ix = 0;
  switch (m_nFractalType)
  {
  
    // Mandelbrot
    case 0:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
        if (7 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"7");
        ix++;
      
        if (8 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"8");
        ix++;
      
        if (9 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"9");
        ix++;
      
        if (10 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"10");
        ix++;
      
      break;
    }
  
    // Burning Ship
    case 1:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Buffalo
    case 2:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Celtic
    case 3:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar
    case 4:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // Mandelbar Celtic
    case 5:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Mandelbrot
    case 6:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Burning Ship
    case 7:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Celtic
    case 8:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Perpendicular Buffalo
    case 9:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Burning Ship
    case 10:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Real
    case 11:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Partial BS Imag
    case 12:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Flying Squirrel (Buffalo Imag)
    case 13:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // Cubic Quasi Perpendicular
    case 14:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Imag
    case 15:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real
    case 16:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Burning Ship Partial Real Mbar
    case 17:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Imag
    case 18:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real
    case 19:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Burning Ship Partial Real Mbar
    case 20:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Buffalo Partial Imag
    case 21:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Mbar
    case 22:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Perpendicular
    case 23:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th False Quasi Heart
    case 24:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi Perpendicular
    case 25:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic False Quasi Heart
    case 26:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial
    case 27:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Burning Ship Partial Mbar
    case 28:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Celtic Mbar
    case 29:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Burning Ship (BS/Buffalo Hybrid)
    case 30:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Perpendicular
    case 31:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // 5th Quasi Heart
    case 32:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // SimonBrot 4th
    case 33:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Imag Quasi Perpendicular / Heart
    case 34:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Perpendicular
    case 35:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Real Quasi Heart
    case 36:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Imag Quasi Perpendicular / Heart
    case 37:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Perpendicular
    case 38:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // 4th Celtic Real Quasi Heart
    case 39:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // SimonBrot 6th
    case 40:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // HPDZ Buffalo
    case 41:
    {
      
        if (2 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"2");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 1: a*z^2+z^3+c
    case 42:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 2: a*z^2-z^3+c
    case 43:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 3: 2*z^2-z^3+c
    case 44:
    {
      
        if (3 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"3");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 4: a*z^2+z^4+c
    case 45:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 5: a*z^2-z^4+c
    case 46:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 6: a*z^2+z^5+c
    case 47:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 7: a*z^2-z^5+c
    case 48:
    {
      
        if (5 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"5");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 8: a*z^2+z^6+c
    case 49:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // TheRedshiftRider 9: a*z^2-z^6+c
    case 50:
    {
      
        if (6 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"6");
        ix++;
      
      break;
    }
  
    // SimonBrot2 4th
    case 51:
    {
      
        if (4 == m_nPower) selected = ix;
        SendDlgItemMessage(hWnd,IDC_COMBO3,CB_ADDSTRING,0,(LPARAM)"4");
        ix++;
      
      break;
    }
  
  }
	SendDlgItemMessage(hWnd,IDC_COMBO3,CB_SETCURSEL,selected,0);
	EnableWindow(GetDlgItem(hWnd,IDC_COMBO3), ix > 1);
}

// EOF
